! $Id: DirectWrite.f90 2116 2016-05-11 11:41:04Z ian $
! Copyright 2016 M.E.G.M.S.  See LICENCE.txt for licence (Apache 2.0).
! See http://www.megms.com.au/winapi-bindings.htm for more information.



!*******************************************************************************

MODULE DirectWrite
  
  USE COMBase
  
  USE, INTRINSIC :: ISO_C_BINDING, ONLY:  &
      C_FUNPTR,  &
      C_INT16_T,  &
      C_INT32_T,  &
      C_PTR,  &
      C_INT,  &
      C_SHORT,  &
      C_LONG
  
  IMPLICIT NONE
  
  PRIVATE
  
  !-----------------------------------------------------------------------------
  
  ! These are actually in DCommon.h.
  
  ENUM, BIND(C)
    ENUMERATOR :: DWRITE_MEASURING_MODE_NATURAL
    ENUMERATOR :: DWRITE_MEASURING_MODE_GDI_CLASSIC
    ENUMERATOR :: DWRITE_MEASURING_MODE_GDI_NATURAL
  END ENUM
  
  PUBLIC :: DWRITE_MEASURING_MODE_NATURAL
  PUBLIC :: DWRITE_MEASURING_MODE_GDI_CLASSIC
  PUBLIC :: DWRITE_MEASURING_MODE_GDI_NATURAL
  INTEGER, PARAMETER, PUBLIC :: DWRITE_MEASURING_MODE  &
      = KIND(DWRITE_MEASURING_MODE_NATURAL)
  
  !-----------------------------------------------------------------------------
  
  ! The order of things being declared here is roughly the same as it 
  ! appears in DWrite.h.
  
  ENUM, BIND(C)
    ENUMERATOR :: DWRITE_FONT_FILE_TYPE_UNKNOWN
    ENUMERATOR :: DWRITE_FONT_FILE_TYPE_CFF
    ENUMERATOR :: DWRITE_FONT_FILE_TYPE_TRUETYPE
    ENUMERATOR :: DWRITE_FONT_FILE_TYPE_TRUETYPE_COLLECTION
    ENUMERATOR :: DWRITE_FONT_FILE_TYPE_TYPE1_PFM
    ENUMERATOR :: DWRITE_FONT_FILE_TYPE_TYPE1_PFB
    ENUMERATOR :: DWRITE_FONT_FILE_TYPE_VECTOR
    ENUMERATOR :: DWRITE_FONT_FILE_TYPE_BITMAP
  END ENUM
  PUBLIC :: DWRITE_FONT_FILE_TYPE_UNKNOWN
  PUBLIC :: DWRITE_FONT_FILE_TYPE_CFF
  PUBLIC :: DWRITE_FONT_FILE_TYPE_TRUETYPE
  PUBLIC :: DWRITE_FONT_FILE_TYPE_TRUETYPE_COLLECTION
  PUBLIC :: DWRITE_FONT_FILE_TYPE_TYPE1_PFM
  PUBLIC :: DWRITE_FONT_FILE_TYPE_TYPE1_PFB
  PUBLIC :: DWRITE_FONT_FILE_TYPE_VECTOR
  PUBLIC :: DWRITE_FONT_FILE_TYPE_BITMAP
  INTEGER, PARAMETER, PUBLIC :: DWRITE_FONT_FILE_TYPE  &
      = KIND(DWRITE_FONT_FILE_TYPE_UNKNOWN)
  
  
  ENUM, BIND(C)
    ENUMERATOR :: DWRITE_FONT_FACE_TYPE_CFF
    ENUMERATOR :: DWRITE_FONT_FACE_TYPE_TRUETYPE
    ENUMERATOR :: DWRITE_FONT_FACE_TYPE_TRUETYPE_COLLECTION
    ENUMERATOR :: DWRITE_FONT_FACE_TYPE_TYPE1
    ENUMERATOR :: DWRITE_FONT_FACE_TYPE_VECTOR
    ENUMERATOR :: DWRITE_FONT_FACE_TYPE_BITMAP
    ENUMERATOR :: DWRITE_FONT_FACE_TYPE_UNKNOWN
    ENUMERATOR :: DWRITE_FONT_FACE_TYPE_RAW_CFF
  END ENUM
  PUBLIC :: DWRITE_FONT_FACE_TYPE_CFF
  PUBLIC :: DWRITE_FONT_FACE_TYPE_TRUETYPE
  PUBLIC :: DWRITE_FONT_FACE_TYPE_TRUETYPE_COLLECTION
  PUBLIC :: DWRITE_FONT_FACE_TYPE_TYPE1
  PUBLIC :: DWRITE_FONT_FACE_TYPE_VECTOR
  PUBLIC :: DWRITE_FONT_FACE_TYPE_BITMAP
  PUBLIC :: DWRITE_FONT_FACE_TYPE_UNKNOWN
  PUBLIC :: DWRITE_FONT_FACE_TYPE_RAW_CFF
  INTEGER, PARAMETER, PUBLIC :: DWRITE_FONT_FACE_TYPE  &
      = KIND(DWRITE_FONT_FACE_TYPE_CFF)
  
  
  ENUM, BIND(C)
    ENUMERATOR :: DWRITE_FONT_SIMULATIONS_NONE
    ENUMERATOR :: DWRITE_FONT_SIMULATIONS_BOLD
    ENUMERATOR :: DWRITE_FONT_SIMULATIONS_OBLIQUE
  END ENUM
  PUBLIC :: DWRITE_FONT_SIMULATIONS_NONE
  PUBLIC :: DWRITE_FONT_SIMULATIONS_BOLD
  PUBLIC :: DWRITE_FONT_SIMULATIONS_OBLIQUE
  INTEGER, PARAMETER, PUBLIC :: DWRITE_FONT_SIMULATIONS  &
      = KIND(DWRITE_FONT_SIMULATIONS)
  
  
  ENUM, BIND(C)
    ENUMERATOR :: DWRITE_FONT_WEIGHT_THIN = 100
    ENUMERATOR :: DWRITE_FONT_WEIGHT_EXTRA_LIGHT = 200
    ENUMERATOR :: DWRITE_FONT_WEIGHT_ULTRA_LIGHT = 200
    ENUMERATOR :: DWRITE_FONT_WEIGHT_LIGHT = 300
    ENUMERATOR :: DWRITE_FONT_WEIGHT_NORMAL = 400
    ENUMERATOR :: DWRITE_FONT_WEIGHT_REGULAR = 400
    ENUMERATOR :: DWRITE_FONT_WEIGHT_MEDIUM = 500
    ENUMERATOR :: DWRITE_FONT_WEIGHT_DEMI_BOLD = 600
    ENUMERATOR :: DWRITE_FONT_WEIGHT_SEMI_BOLD = 600
    ENUMERATOR :: DWRITE_FONT_WEIGHT_BOLD = 700
    ENUMERATOR :: DWRITE_FONT_WEIGHT_EXTRA_BOLD = 800
    ENUMERATOR :: DWRITE_FONT_WEIGHT_ULTRA_BOLD = 800
    ENUMERATOR :: DWRITE_FONT_WEIGHT_BLACK = 900
    ENUMERATOR :: DWRITE_FONT_WEIGHT_HEAVY = 900
    ENUMERATOR :: DWRITE_FONT_WEIGHT_EXTRA_BLACK = 950
    ENUMERATOR :: DWRITE_FONT_WEIGHT_ULTRA_BLACK = 950
  END ENUM
  PUBLIC :: DWRITE_FONT_WEIGHT_THIN
  PUBLIC :: DWRITE_FONT_WEIGHT_EXTRA_LIGHT
  PUBLIC :: DWRITE_FONT_WEIGHT_ULTRA_LIGHT
  PUBLIC :: DWRITE_FONT_WEIGHT_LIGHT
  PUBLIC :: DWRITE_FONT_WEIGHT_NORMAL
  PUBLIC :: DWRITE_FONT_WEIGHT_REGULAR
  PUBLIC :: DWRITE_FONT_WEIGHT_MEDIUM
  PUBLIC :: DWRITE_FONT_WEIGHT_DEMI_BOLD
  PUBLIC :: DWRITE_FONT_WEIGHT_SEMI_BOLD
  PUBLIC :: DWRITE_FONT_WEIGHT_BOLD
  PUBLIC :: DWRITE_FONT_WEIGHT_EXTRA_BOLD
  PUBLIC :: DWRITE_FONT_WEIGHT_ULTRA_BOLD
  PUBLIC :: DWRITE_FONT_WEIGHT_BLACK
  PUBLIC :: DWRITE_FONT_WEIGHT_HEAVY
  PUBLIC :: DWRITE_FONT_WEIGHT_EXTRA_BLACK
  PUBLIC :: DWRITE_FONT_WEIGHT_ULTRA_BLACK
  INTEGER, PARAMETER, PUBLIC :: DWRITE_FONT_WEIGHT  &
      = KIND(DWRITE_FONT_WEIGHT_THIN)
  
  
  ENUM, BIND(C) 
    ENUMERATOR :: DWRITE_FONT_STRETCH_UNDEFINED = 0
    ENUMERATOR :: DWRITE_FONT_STRETCH_ULTRA_CONDENSED = 1
    ENUMERATOR :: DWRITE_FONT_STRETCH_EXTRA_CONDENSED = 2
    ENUMERATOR :: DWRITE_FONT_STRETCH_CONDENSED = 3
    ENUMERATOR :: DWRITE_FONT_STRETCH_SEMI_CONDENSED = 4
    ENUMERATOR :: DWRITE_FONT_STRETCH_NORMAL = 5
    ENUMERATOR :: DWRITE_FONT_STRETCH_MEDIUM = 5
    ENUMERATOR :: DWRITE_FONT_STRETCH_SEMI_EXPANDED = 6
    ENUMERATOR :: DWRITE_FONT_STRETCH_EXPANDED = 7
    ENUMERATOR :: DWRITE_FONT_STRETCH_EXTRA_EXPANDED = 8
    ENUMERATOR :: DWRITE_FONT_STRETCH_ULTRA_EXPANDED = 9
  END ENUM
  PUBLIC :: DWRITE_FONT_STRETCH_UNDEFINED
  PUBLIC :: DWRITE_FONT_STRETCH_ULTRA_CONDENSED
  PUBLIC :: DWRITE_FONT_STRETCH_EXTRA_CONDENSED
  PUBLIC :: DWRITE_FONT_STRETCH_CONDENSED
  PUBLIC :: DWRITE_FONT_STRETCH_SEMI_CONDENSED
  PUBLIC :: DWRITE_FONT_STRETCH_NORMAL
  PUBLIC :: DWRITE_FONT_STRETCH_MEDIUM
  PUBLIC :: DWRITE_FONT_STRETCH_SEMI_EXPANDED
  PUBLIC :: DWRITE_FONT_STRETCH_EXPANDED
  PUBLIC :: DWRITE_FONT_STRETCH_EXTRA_EXPANDED
  PUBLIC :: DWRITE_FONT_STRETCH_ULTRA_EXPANDED
  INTEGER, PARAMETER, PUBLIC :: DWRITE_FONT_STRETCH  &
      = KIND(DWRITE_FONT_STRETCH_UNDEFINED)
  
      
  ENUM, BIND(C)
    ENUMERATOR :: DWRITE_FONT_STYLE_NORMAL
    ENUMERATOR :: DWRITE_FONT_STYLE_OBLIQUE
    ENUMERATOR :: DWRITE_FONT_STYLE_ITALIC
  END ENUM
  PUBLIC :: DWRITE_FONT_STYLE_NORMAL
  PUBLIC :: DWRITE_FONT_STYLE_OBLIQUE
  PUBLIC :: DWRITE_FONT_STYLE_ITALIC
  INTEGER, PARAMETER, PUBLIC :: DWRITE_FONT_STYLE  &
      = KIND(DWRITE_FONT_STYLE_NORMAL)
  
  
  ENUM, BIND(C)
    ENUMERATOR :: DWRITE_INFORMATIONAL_STRING_NONE
    ENUMERATOR :: DWRITE_INFORMATIONAL_STRING_COPYRIGHT_NOTICE
    ENUMERATOR :: DWRITE_INFORMATIONAL_STRING_VERSION_STRINGS
    ENUMERATOR :: DWRITE_INFORMATIONAL_STRING_TRADEMARK
    ENUMERATOR :: DWRITE_INFORMATIONAL_STRING_MANUFACTURER
    ENUMERATOR :: DWRITE_INFORMATIONAL_STRING_DESIGNER
    ENUMERATOR :: DWRITE_INFORMATIONAL_STRING_DESIGNER_URL
    ENUMERATOR :: DWRITE_INFORMATIONAL_STRING_DESCRIPTION
    ENUMERATOR :: DWRITE_INFORMATIONAL_STRING_FONT_VENDOR_URL
    ENUMERATOR :: DWRITE_INFORMATIONAL_STRING_LICENSE_DESCRIPTION
    ENUMERATOR :: DWRITE_INFORMATIONAL_STRING_LICENSE_INFO_URL
    ENUMERATOR :: DWRITE_INFORMATIONAL_STRING_WIN32_FAMILY_NAMES
    ENUMERATOR :: DWRITE_INFORMATIONAL_STRING_WIN32_SUBFAMILY_NAMES
    ENUMERATOR :: DWRITE_INFORMATIONAL_STRING_PREFERRED_FAMILY_NAMES
    ENUMERATOR :: DWRITE_INFORMATIONAL_STRING_PREFERRED_SUBFAMILY_NAMES
    ENUMERATOR :: DWRITE_INFORMATIONAL_STRING_SAMPLE_TEXT
  END ENUM
  PUBLIC :: DWRITE_INFORMATIONAL_STRING_NONE
  PUBLIC :: DWRITE_INFORMATIONAL_STRING_COPYRIGHT_NOTICE
  PUBLIC :: DWRITE_INFORMATIONAL_STRING_VERSION_STRINGS
  PUBLIC :: DWRITE_INFORMATIONAL_STRING_TRADEMARK
  PUBLIC :: DWRITE_INFORMATIONAL_STRING_MANUFACTURER
  PUBLIC :: DWRITE_INFORMATIONAL_STRING_DESIGNER
  PUBLIC :: DWRITE_INFORMATIONAL_STRING_DESIGNER_URL
  PUBLIC :: DWRITE_INFORMATIONAL_STRING_DESCRIPTION
  PUBLIC :: DWRITE_INFORMATIONAL_STRING_FONT_VENDOR_URL
  PUBLIC :: DWRITE_INFORMATIONAL_STRING_LICENSE_DESCRIPTION
  PUBLIC :: DWRITE_INFORMATIONAL_STRING_LICENSE_INFO_URL
  PUBLIC :: DWRITE_INFORMATIONAL_STRING_WIN32_FAMILY_NAMES
  PUBLIC :: DWRITE_INFORMATIONAL_STRING_WIN32_SUBFAMILY_NAMES
  PUBLIC :: DWRITE_INFORMATIONAL_STRING_PREFERRED_FAMILY_NAMES
  PUBLIC :: DWRITE_INFORMATIONAL_STRING_PREFERRED_SUBFAMILY_NAMES
  PUBLIC :: DWRITE_INFORMATIONAL_STRING_SAMPLE_TEXT
  INTEGER, PARAMETER, PUBLIC :: DWRITE_INFORMATIONAL_STRING_ID  &
       = KIND(DWRITE_INFORMATIONAL_STRING_NONE)
  
  
  TYPE, BIND(C), PUBLIC :: DWRITE_FONT_METRICS
    INTEGER(UINT16) :: designUnitsPerEm
    INTEGER(UINT16) :: ascent
    INTEGER(UINT16) :: descent
    INTEGER(INT16) :: lineGap
    INTEGER(UINT16) :: capHeight
    INTEGER(UINT16) :: xHeight
    INTEGER(INT16) :: underlinePosition
    INTEGER(UINT16) :: underlineThickness
    INTEGER(INT16) :: strikethroughPosition
    INTEGER(UINT16) :: strikethroughThickness
  END TYPE DWRITE_FONT_METRICS
  
  
  TYPE, BIND(C), PUBLIC :: DWRITE_GLYPH_METRICS
    INTEGER(INT32) :: leftSideBearing
    INTEGER(UINT32) :: advanceWidth
    INTEGER(INT32) :: rightSideBearing
    INTEGER(INT32) :: topSideBearing
    INTEGER(UINT32) :: advanceHeight
    INTEGER(INT32) :: bottomSideBearing
    INTEGER(INT32) :: verticalOriginY
  END TYPE DWRITE_GLYPH_METRICS
  
  
  TYPE, BIND(C), PUBLIC :: DWRITE_GLYPH_OFFSET
    REAL(FLOAT) :: advanceOffset
    REAL(FLOAT) :: ascenderOffset
  END TYPE DWRITE_GLYPH_OFFSET
  
  
  ENUM, BIND(C)
    ENUMERATOR :: DWRITE_FACTORY_TYPE_SHARED
    ENUMERATOR :: DWRITE_FACTORY_TYPE_ISOLATED
  END ENUM
  PUBLIC :: DWRITE_FACTORY_TYPE_SHARED
  PUBLIC :: DWRITE_FACTORY_TYPE_ISOLATED
  INTEGER, PARAMETER, PUBLIC :: DWRITE_FACTORY_TYPE  &
      = KIND(DWRITE_FACTORY_TYPE_SHARED)
  
  
  ! Macro implemented as a function.
  PUBLIC :: DWRITE_MAKE_OPENTYPE_TAG
  
  !-----------------------------------------------------------------------------
  ! "727cad4e-d6af-4c9e-8a08-d695b11caa49"  IDWriteFontFileLoader
  
  TYPE, BIND(C) :: IDWriteFontFileLoaderVTbl
    TYPE(IUnknownVTbl) :: Base
    TYPE(C_FUNPTR) :: CreateStreamFromKey
  END TYPE IDWriteFontFileLoaderVTbl
  
  ABSTRACT INTERFACE
    FUNCTION CreateStreamFromKey_intf( this, fontFileReferenceKey,  &
        fontFileReferenceKeySize, fontFileStream )
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: UINT32
      IMPORT :: HRESULT
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      TYPE(C_PTR), INTENT(IN) :: fontFileReferenceKey
      INTEGER(UINT32), INTENT(IN) :: fontFileReferenceKeySize
      TYPE(C_PTR), INTENT(OUT) :: fontFileStream
      !DEC$ ATTRIBUTES REFERENCE :: fontFileStream
      INTEGER(HRESULT) :: CreateStreamFromKey_intf
      !DEC$ ATTRIBUTES STDCALL :: CreateStreamFromKey_intf
    END FUNCTION CreateStreamFromKey_intf
  END INTERFACE
  
  TYPE, EXTENDS(IUnknown) :: IDWriteFontFileLoader
  CONTAINS
    PROCEDURE, NOPASS :: IID => fontfileloader_IID
  END TYPE IDWriteFontFileLoader
  
  !-----------------------------------------------------------------------------
  ! "b2d9f3ec-c9fe-4a11-a2ec-d86208f7c0a2"  IDWriteLocalFontFileLoader
  
  TYPE, BIND(C) :: IDWriteLocalFontFileLoaderVTbl
    TYPE(IDWriteFontFileLoaderVTbl) :: Base
    TYPE(C_FUNPTR) :: GetFilePathLengthFromKey
    TYPE(C_FUNPTR) :: GetFilePathFromKey
    TYPE(C_FUNPTR) :: GetLastWriteTimeFromKey
  END TYPE IDWriteLocalFontFileLoaderVTbl
  
  ABSTRACT INTERFACE
    FUNCTION GetFilePathLengthFromKey_intf( this, fontFileReferenceKey,  &
        fontFileReferenceKeySize, filePathLength )
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: UINT32
      IMPORT :: HRESULT
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      TYPE(C_PTR), INTENT(IN) :: fontFileReferenceKey
      INTEGER(UINT32), INTENT(IN) :: fontFileReferenceKeySize
      INTEGER(UINT32), INTENT(OUT) :: filePathLength
      !DEC$ ATTRIBUTES REFERENCE :: filePathLength
      INTEGER(HRESULT) :: GetFilePathLengthFromKey_intf
      !DEC$ ATTRIBUTES STDCALL :: GetFilePathLengthFromKey_intf
    END FUNCTION GetFilePathLengthFromKey_intf
    
    FUNCTION GetFilePathFromKey_intf( this, fontFileReferenceKey,  &
        fontFileReferenceKeySize, filePath, filePathSize )
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: UINT32
      IMPORT :: WCHAR
      IMPORT :: HRESULT
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      TYPE(C_PTR), INTENT(IN) :: fontFileReferenceKey
      INTEGER(UINT32), INTENT(IN) :: fontFileReferenceKeySize
      INTEGER(WCHAR), INTENT(OUT) :: filePath(*)
      !DEC$ ATTRIBUTES REFERENCE :: filePath
      INTEGER(UINT32), INTENT(IN) :: filePathSize
      INTEGER(HRESULT) :: GetFilePathFromKey_intf
      !DEC$ ATTRIBUTES STDCALL :: GetFilePathFromKey_intf
    END FUNCTION GetFilePathFromKey_intf
    
    FUNCTION GetLastWriteTimeFromKey_intf( this, fontFileReferenceKey,  &
        fontFileReferenceKeySize, lastWriteTime )
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: UINT32
      IMPORT :: DWORD
      IMPORT :: HRESULT
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      TYPE(C_PTR), INTENT(IN) :: fontFileReferenceKey
      INTEGER(UINT32), INTENT(IN) :: fontFileReferenceKeySize
      ! This is just a placeholder - we really should define this 
      ! somewhere else.
      TYPE, BIND(C) :: FILETIME
        INTEGER(DWORD) :: dwLowDateTime
        INTEGER(DWORD) :: dwHighDateTime
      END TYPE FILETIME
      TYPE(FILETIME), INTENT(OUT) :: lastWriteTime
      !DEC$ ATTRIBUTES REFERENCE :: lastWriteTime
      INTEGER(HRESULT) :: GetLastWriteTimeFromKey_intf
      !DEC$ ATTRIBUTES STDCALL :: GetLastWriteTimeFromKey_intf
    END FUNCTION GetLastWriteTimeFromKey_intf
  END INTERFACE
  
  TYPE, EXTENDS(IDWriteFontFileLoader) :: IDWriteLocalFontFileLoader
  CONTAINS
    PROCEDURE, NOPASS :: IID => localfontfileloader_IID
  END TYPE IDWriteLocalFontFileLoader
  
  !-----------------------------------------------------------------------------
  ! "6d4865fe-0ab8-4d91-8f62-5dd6be34a3e0"  IDWriteFontFileStream
  
  TYPE, BIND(C) :: IDWriteFontFileStreamVTbl
    TYPE(IUnknownVTbl) :: Base
    TYPE(C_FUNPTR) :: ReadFileFragment
    TYPE(C_FUNPTR) :: ReleaseFileFragment
    TYPE(C_FUNPTR) :: GetFileSize
    TYPE(C_FUNPTR) :: GetLastWriteTime
  END TYPE IDWriteFontFileStreamVTbl
  
  ABSTRACT INTERFACE
    FUNCTION ReadFileFragment_intf( this, fragmentStart,  &
        fileOffset, fragmentSize, fragmentContext )
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: UINT64
      IMPORT :: HRESULT
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      TYPE(C_PTR), INTENT(IN) :: fragmentStart
      INTEGER(UINT64), INTENT(IN) :: fileOffset
      INTEGER(UINT64), INTENT(IN) :: fragmentSize
      TYPE(C_PTR), INTENT(OUT) :: fragmentContext
      !DEC$ ATTRIBUTES REFERENCE :: fragmentContext
      INTEGER(HRESULT) :: ReadFileFragment_intf
      !DEC$ ATTRIBUTES STDCALL :: ReadFileFragment_intf
    END FUNCTION ReadFileFragment_intf
    
    SUBROUTINE ReleaseFileFragment_intf(this, fragmentContext)
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      TYPE(C_PTR), INTENT(IN) :: fragmentContext
      !DEC$ ATTRIBUTES STDCALL :: ReleaseFileFragment_intf
    END SUBROUTINE ReleaseFileFragment_intf
    
    FUNCTION GetFileSize_intf(this, fileSize)
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: UINT64
      IMPORT :: HRESULT
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      INTEGER(UINT64), INTENT(IN) :: fileSize
      !DEC$ ATTRIBUTES REFERENCE :: fileSize
      INTEGER(HRESULT) :: GetFileSize_intf
      !DEC$ ATTRIBUTES STDCALL :: GetFileSize_intf
    END FUNCTION GetFileSize_intf
    
    FUNCTION GetLastWriteTime_intf(this, lastWriteTime)
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: UINT64
      IMPORT :: HRESULT
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      INTEGER(UINT64), INTENT(IN) :: lastWriteTime
      !DEC$ ATTRIBUTES REFERENCE :: lastWriteTime
      INTEGER(HRESULT) :: GetLastWriteTime_intf
      !DEC$ ATTRIBUTES STDCALL :: GetLastWriteTime_intf
    END FUNCTION GetLastWriteTime_intf
  END INTERFACE
  
  TYPE, EXTENDS(IUnknown) :: IDWriteFontFileStream
  CONTAINS
    PROCEDURE, NOPASS :: IID => fontfilestream_IID
  END TYPE IDWriteFontFileStream
  
  !-----------------------------------------------------------------------------
  ! "739d886a-cef5-47dc-8769-1a8b41bebbb0"  IDWriteFontFile
  
  TYPE, BIND(C) :: IDWriteFontFileVTbl
    TYPE(IUnknownVTbl) :: Base
    TYPE(C_FUNPTR) :: GetReferenceKey
    TYPE(C_FUNPTR) :: GetLoader
    TYPE(C_FUNPTR) :: Analyze
  END TYPE IDWriteFontFileVTbl
  
  ABSTRACT INTERFACE
    FUNCTION GetReferenceKey_intf( this, fontFileReferenceKey,  &
        fontFileReferenceKeySize )
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: UINT32
      IMPORT :: HRESULT
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      TYPE(C_PTR), INTENT(OUT) :: fontFileReferenceKey
      !DEC$ ATTRIBUTES REFERENCE :: fontFileReferenceKey
      INTEGER(UINT32), INTENT(OUT) :: fontFileReferenceKeySize
      !DEC$ ATTRIBUTES REFERENCE :: fontFileReferenceKeySize
      INTEGER(HRESULT) :: GetReferenceKey_intf
      !DEC$ ATTRIBUTES STDCALL :: GetReferenceKey_intf
    END FUNCTION GetReferenceKey_intf
    
    FUNCTION GetLoader_intf(this, fontFileLoader)
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: UINT32
      IMPORT :: HRESULT
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      TYPE(C_PTR), INTENT(OUT) :: fontFileLoader
      !DEC$ ATTRIBUTES REFERENCE :: fontFileLoader
      INTEGER(HRESULT) :: GetLoader_intf
      !DEC$ ATTRIBUTES STDCALL :: GetLoader_intf
    END FUNCTION GetLoader_intf
    
    FUNCTION Analyze_intf( this, isSupportedFontType, fontFileType,  &
        fontFaceType, numberOfFaces )
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: BOOL
      IMPORT :: DWRITE_FONT_FILE_TYPE
      IMPORT :: DWRITE_FONT_FACE_TYPE
      IMPORT :: UINT32
      IMPORT :: HRESULT
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      INTEGER(BOOL), INTENT(OUT) :: isSupportedFontType
      !DEC$ ATTRIBUTES REFERENCE :: isSupportedFontType
      INTEGER(DWRITE_FONT_FILE_TYPE), INTENT(OUT) :: fontFileType
      !DEC$ ATTRIBUTES REFERENCE :: fontFileType
      INTEGER(DWRITE_FONT_FACE_TYPE), INTENT(OUT) :: fontFaceType
      !DEC$ ATTRIBUTES REFERENCE :: fontFaceType
      INTEGER(UINT32), INTENT(OUT) :: numberOfFaces
      !DEC$ ATTRIBUTES REFERENCE :: numberOfFaces
      INTEGER(HRESULT) :: Analyze_intf
      !DEC$ ATTRIBUTES STDCALL :: Analyze_intf
    END FUNCTION Analyze_intf
  END INTERFACE
  
  TYPE, EXTENDS(IUnknown) :: IDWriteFontFile
  CONTAINS
    PROCEDURE, NOPASS :: IID => fontfile_IID
  END TYPE IDWriteFontFile
  
  !-----------------------------------------------------------------------------
  
  ENUM, BIND(C)
    ENUMERATOR :: DWRITE_PIXEL_GEOMETRY_FLAT
    ENUMERATOR :: DWRITE_PIXEL_GEOMETRY_RGB
    ENUMERATOR :: DWRITE_PIXEL_GEOMETRY_BGR
  END ENUM
  PUBLIC :: DWRITE_PIXEL_GEOMETRY_FLAT
  PUBLIC :: DWRITE_PIXEL_GEOMETRY_RGB
  PUBLIC :: DWRITE_PIXEL_GEOMETRY_BGR
  INTEGER, PARAMETER, PUBLIC :: DWRITE_PIXEL_GEOMETRY  &
       = KIND(DWRITE_PIXEL_GEOMETRY_FLAT)
  
  
  ENUM, BIND(C)
    ENUMERATOR :: DWRITE_RENDERING_MODE_DEFAULT
    ENUMERATOR :: DWRITE_RENDERING_MODE_ALIASED
    ENUMERATOR :: DWRITE_RENDERING_MODE_GDI_CLASSIC
    ENUMERATOR :: DWRITE_RENDERING_MODE_GDI_NATURAL
    ENUMERATOR :: DWRITE_RENDERING_MODE_NATURAL
    ENUMERATOR :: DWRITE_RENDERING_MODE_NATURAL_SYMMETRIC
    ENUMERATOR :: DWRITE_RENDERING_MODE_OUTLINE
    ENUMERATOR :: DWRITE_RENDERING_MODE_CLEARTYPE_GDI_CLASSIC  &
        = DWRITE_RENDERING_MODE_GDI_CLASSIC
    ENUMERATOR :: DWRITE_RENDERING_MODE_CLEARTYPE_GDI_NATURAL  &
        = DWRITE_RENDERING_MODE_GDI_NATURAL
    ENUMERATOR :: DWRITE_RENDERING_MODE_CLEARTYPE_NATURAL  &
        = DWRITE_RENDERING_MODE_NATURAL
    ENUMERATOR :: DWRITE_RENDERING_MODE_CLEARTYPE_NATURAL_SYMMETRIC  &
        = DWRITE_RENDERING_MODE_NATURAL_SYMMETRIC
  END ENUM
  PUBLIC :: DWRITE_RENDERING_MODE_DEFAULT
  PUBLIC :: DWRITE_RENDERING_MODE_ALIASED
  PUBLIC :: DWRITE_RENDERING_MODE_GDI_CLASSIC
  PUBLIC :: DWRITE_RENDERING_MODE_GDI_NATURAL
  PUBLIC :: DWRITE_RENDERING_MODE_NATURAL
  PUBLIC :: DWRITE_RENDERING_MODE_NATURAL_SYMMETRIC
  PUBLIC :: DWRITE_RENDERING_MODE_OUTLINE
  PUBLIC :: DWRITE_RENDERING_MODE_CLEARTYPE_GDI_CLASSIC
  PUBLIC :: DWRITE_RENDERING_MODE_CLEARTYPE_GDI_NATURAL
  PUBLIC :: DWRITE_RENDERING_MODE_CLEARTYPE_NATURAL
  PUBLIC :: DWRITE_RENDERING_MODE_CLEARTYPE_NATURAL_SYMMETRIC
  INTEGER, PARAMETER, PUBLIC :: DWRITE_RENDERING_MODE  &
       = KIND(DWRITE_RENDERING_MODE_DEFAULT)
  
  
  ! This is the same, data type wise, as a D2D1_MATRIX_3X2_F (but field 
  ! names are different.
  TYPE, BIND(C), PUBLIC :: DWRITE_MATRIX
    REAL(FLOAT) :: m11
    REAL(FLOAT) :: m12
    REAL(FLOAT) :: m21
    REAL(FLOAT) :: m22
    REAL(FLOAT) :: dx
    REAL(FLOAT) :: dy
  END TYPE DWRITE_MATRIX
  
  !-----------------------------------------------------------------------------
  ! "2f0da53a-2add-47cd-82ee-d9ec34688e75"  IDWriteRenderingParams
  
  TYPE, BIND(C) :: IDWriteRenderingParamsVTbl
    TYPE(IUnknownVTbl) :: Base
    TYPE(C_FUNPTR) :: GetGamma
    TYPE(C_FUNPTR) :: GetEnhancedContrast
    TYPE(C_FUNPTR) :: GetClearTypeLevel
    TYPE(C_FUNPTR) :: GetPixelGeometry
    TYPE(C_FUNPTR) :: GetRenderingMode
  END TYPE IDWriteRenderingParamsVTbl
  
  ABSTRACT INTERFACE
    FUNCTION GetGamma_intf(this)
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: FLOAT
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      REAL(FLOAT) :: GetGamma_intf
      !DEC$ ATTRIBUTES STDCALL :: GetGamma_intf
    END FUNCTION GetGamma_intf
    
    FUNCTION GetEnhancedContrast_intf(this)
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: FLOAT
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      REAL(FLOAT) :: GetEnhancedContrast_intf
      !DEC$ ATTRIBUTES STDCALL :: GetEnhancedContrast_intf
    END FUNCTION GetEnhancedContrast_intf
    
    FUNCTION GetClearTypeLevel_intf(this)
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: FLOAT
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      REAL(FLOAT) :: GetClearTypeLevel_intf
      !DEC$ ATTRIBUTES STDCALL :: GetClearTypeLevel_intf
    END FUNCTION GetClearTypeLevel_intf
    
    FUNCTION GetPixelGeometry_intf(this)
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: DWRITE_PIXEL_GEOMETRY
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      INTEGER(DWRITE_PIXEL_GEOMETRY) :: GetPixelGeometry_intf
      !DEC$ ATTRIBUTES STDCALL :: GetPixelGeometry_intf
    END FUNCTION GetPixelGeometry_intf
    
    FUNCTION GetRenderingMode_intf(this)
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: DWRITE_RENDERING_MODE
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      INTEGER(DWRITE_RENDERING_MODE) :: GetRenderingMode_intf
      !DEC$ ATTRIBUTES STDCALL :: GetRenderingMode_intf
    END FUNCTION GetRenderingMode_intf
  END INTERFACE
  
  TYPE, EXTENDS(IUnknown), PUBLIC :: IDWriteRenderingParams
  CONTAINS
    PROCEDURE, NOPASS :: IID => renderingparams_IID
  END TYPE IDWriteRenderingParams
  
  
  ! Interface ID2D1SimplifiedGeometrySink and ID2D1DWriteGeometry sink 
  ! elided (see the DirectWrite module).
  
  !-----------------------------------------------------------------------------
  ! "5f49804d-7024-4d43-bfa9-d25984f53849"  IDWriteFontFace
  
  TYPE, BIND(C) :: IDWriteFontFaceVTbl
    TYPE(IUnknownVTbl) :: Base
    TYPE(C_FUNPTR) :: GetType
    TYPE(C_FUNPTR) :: GetFiles
    TYPE(C_FUNPTR) :: GetIndex
    TYPE(C_FUNPTR) :: GetSimulations
    TYPE(C_FUNPTR) :: IsSymbolFont
    TYPE(C_FUNPTR) :: GetMetrics
    TYPE(C_FUNPTR) :: GetGlyphCount
    TYPE(C_FUNPTR) :: GetDesignGlyphMetrics
    TYPE(C_FUNPTR) :: GetGlyphIndices
    TYPE(C_FUNPTR) :: TryGetFontTable
    TYPE(C_FUNPTR) :: ReleaseFontTable
    TYPE(C_FUNPTR) :: GetGlyphRunOutline
    TYPE(C_FUNPTR) :: GetRecommendedRenderingMode
    TYPE(C_FUNPTR) :: GetGdiCompatibleMetrics
    TYPE(C_FUNPTR) :: GetGdiCompatibleGlyphMetrics
  END TYPE IDWriteFontFaceVTbl
  
  ABSTRACT INTERFACE
    
  END INTERFACE
  
  TYPE, EXTENDS(IUnknown), PUBLIC :: IDWriteFontFace
  CONTAINS
    PROCEDURE, NOPASS :: IID => fontface_IID
  END TYPE IDWriteFontFace
  
  ! Forward declarations of IDWriteFactory and IDWriteFontFileEnumerator.
  
  !-----------------------------------------------------------------------------
  ! "cca920e4-52f0-492b-bfa8-29c72ee0a468"  IDWriteFontCollectionLoader
  
  TYPE, EXTENDS(IUnknown), PUBLIC :: IDWriteFontCollectionLoader
  CONTAINS
    PROCEDURE, NOPASS :: IID => fontcollectionloader_IID
  END TYPE IDWriteFontCollectionLoader
  
  !-----------------------------------------------------------------------------
  ! "72755049-5ff7-435d-8348-4be97cfa6c7c"  IDWriteFontFileEnumerator
  
  TYPE, EXTENDS(IUnknown), PUBLIC :: IDWriteFontFileEnumerator
  CONTAINS
    PROCEDURE, NOPASS :: IID => fontfileenumerator_IID
  END TYPE IDWriteFontFileEnumerator
  
  !-----------------------------------------------------------------------------
  ! "08256209-099a-4b34-b86d-c22b110e7771"  IDWriteLocalizedStrings
  
  TYPE, EXTENDS(IUnknown), PUBLIC :: IDWriteLocalizedStrings
  CONTAINS
    PROCEDURE, NOPASS :: IID => localizedstrings_IID
  END TYPE IDWriteLocalizedStrings
  
  ! Forward declarations of IDWriteFontFamily and IDWriteFont elided.
  
  !-----------------------------------------------------------------------------
  ! "a84cee02-3eea-4eee-a827-87c1a02a0fcc"  IDWriteFontCollection
  
  TYPE, EXTENDS(IUnknown), PUBLIC :: IDWriteFontCollection
  CONTAINS
    PROCEDURE, NOPASS :: IID => fontcollection_IID
  END TYPE IDWriteFontCollection
  
  !-----------------------------------------------------------------------------
  ! "1a0d8438-1d97-4ec1-aef9-a2fb86ed6acb"  IDWriteFontList
  
  TYPE, EXTENDS(IUnknown), PUBLIC :: IDWriteFontList
  CONTAINS
    PROCEDURE, NOPASS :: IID => fontlist_IID
  END TYPE IDWriteFontList
  
  !-----------------------------------------------------------------------------
  ! "da20d8ef-812a-4c43-9802-62ec4abd7add"  IDWriteFontFamily
  
  TYPE, EXTENDS(IDWriteFontList), PUBLIC :: IDWriteFontFamily
  CONTAINS
    PROCEDURE, NOPASS :: IID => fontfamily_IID
  END TYPE IDWriteFontFamily
  
  !-----------------------------------------------------------------------------
  ! "acd16696-8c14-4f5d-877e-fe3fc1d32737"  IDWriteFont
  
  TYPE, EXTENDS(IUnknown), PUBLIC :: IDWriteFont
  CONTAINS
    PROCEDURE, NOPASS :: IID => font_IID
  END TYPE IDWriteFont
  
  !-----------------------------------------------------------------------------
  
  ENUM, BIND(C)
    ENUMERATOR :: DWRITE_READING_DIRECTION_LEFT_TO_RIGHT = 0
    ENUMERATOR :: DWRITE_READING_DIRECTION_RIGHT_TO_LEFT = 1
    ENUMERATOR :: DWRITE_READING_DIRECTION_TOP_TO_BOTTOM = 2
    ENUMERATOR :: DWRITE_READING_DIRECTION_BOTTOM_TO_TOP = 3
  END ENUM
  PUBLIC :: DWRITE_READING_DIRECTION_LEFT_TO_RIGHT
  PUBLIC :: DWRITE_READING_DIRECTION_RIGHT_TO_LEFT
  PUBLIC :: DWRITE_READING_DIRECTION_TOP_TO_BOTTOM
  PUBLIC :: DWRITE_READING_DIRECTION_BOTTOM_TO_TOP
  INTEGER, PARAMETER, PUBLIC :: DWRITE_READING_DIRECTION  &
      = KIND(DWRITE_READING_DIRECTION_LEFT_TO_RIGHT)
  
  
  ENUM, BIND(C)
    ENUMERATOR :: DWRITE_FLOW_DIRECTION_TOP_TO_BOTTOM = 0
    ENUMERATOR :: DWRITE_FLOW_DIRECTION_BOTTOM_TO_TOP = 1
    ENUMERATOR :: DWRITE_FLOW_DIRECTION_LEFT_TO_RIGHT = 2
    ENUMERATOR :: DWRITE_FLOW_DIRECTION_RIGHT_TO_LEFT = 3
  END ENUM
  PUBLIC :: DWRITE_FLOW_DIRECTION_TOP_TO_BOTTOM
  PUBLIC :: DWRITE_FLOW_DIRECTION_BOTTOM_TO_TOP
  PUBLIC :: DWRITE_FLOW_DIRECTION_LEFT_TO_RIGHT
  PUBLIC :: DWRITE_FLOW_DIRECTION_RIGHT_TO_LEFT
  INTEGER, PARAMETER, PUBLIC :: DWRITE_FLOW_DIRECTION  &
      = KIND(DWRITE_FLOW_DIRECTION_TOP_TO_BOTTOM)
  
  
  ENUM, BIND(C)
    ENUMERATOR :: DWRITE_TEXT_ALIGNMENT_LEADING
    ENUMERATOR :: DWRITE_TEXT_ALIGNMENT_TRAILING
    ENUMERATOR :: DWRITE_TEXT_ALIGNMENT_CENTER
    ENUMERATOR :: DWRITE_TEXT_ALIGNMENT_JUSTIFIED
  END ENUM
  PUBLIC :: DWRITE_TEXT_ALIGNMENT_LEADING
  PUBLIC :: DWRITE_TEXT_ALIGNMENT_TRAILING
  PUBLIC :: DWRITE_TEXT_ALIGNMENT_CENTER
  PUBLIC :: DWRITE_TEXT_ALIGNMENT_JUSTIFIED
  INTEGER, PARAMETER, PUBLIC :: DWRITE_TEXT_ALIGNMENT  &
      = KIND(DWRITE_TEXT_ALIGNMENT_LEADING)
  
  
  ENUM, BIND(C)
    ENUMERATOR :: DWRITE_PARAGRAPH_ALIGNMENT_NEAR
    ENUMERATOR :: DWRITE_PARAGRAPH_ALIGNMENT_FAR
    ENUMERATOR :: DWRITE_PARAGRAPH_ALIGNMENT_CENTER
  END ENUM
  PUBLIC :: DWRITE_PARAGRAPH_ALIGNMENT_NEAR
  PUBLIC :: DWRITE_PARAGRAPH_ALIGNMENT_FAR
  PUBLIC :: DWRITE_PARAGRAPH_ALIGNMENT_CENTER
  INTEGER, PARAMETER, PUBLIC :: DWRITE_PARAGRAPH_ALIGNMENT  &
      = KIND(DWRITE_PARAGRAPH_ALIGNMENT_NEAR)
  
  
  ENUM, BIND(C)
    ENUMERATOR :: DWRITE_WORD_WRAPPING_WRAP = 0
    ENUMERATOR :: DWRITE_WORD_WRAPPING_NO_WRAP = 1
    ENUMERATOR :: DWRITE_WORD_WRAPPING_EMERGENCY_BREAK = 2
    ENUMERATOR :: DWRITE_WORD_WRAPPING_WHOLE_WORD = 3
    ENUMERATOR :: DWRITE_WORD_WRAPPING_CHARACTER = 4
  END ENUM
  PUBLIC :: DWRITE_WORD_WRAPPING_WRAP
  PUBLIC :: DWRITE_WORD_WRAPPING_NO_WRAP
  PUBLIC :: DWRITE_WORD_WRAPPING_EMERGENCY_BREAK
  PUBLIC :: DWRITE_WORD_WRAPPING_WHOLE_WORD
  PUBLIC :: DWRITE_WORD_WRAPPING_CHARACTER
  INTEGER, PARAMETER, PUBLIC :: DWRITE_WORD_WRAPPING  &
      = KIND(DWRITE_WORD_WRAPPING_WRAP)
  
  
  ENUM, BIND(C)
    ENUMERATOR :: DWRITE_LINE_SPACING_METHOD_DEFAULT
    ENUMERATOR :: DWRITE_LINE_SPACING_METHOD_UNIFORM
  END ENUM
  PUBLIC :: DWRITE_LINE_SPACING_METHOD_DEFAULT
  PUBLIC :: DWRITE_LINE_SPACING_METHOD_UNIFORM
  INTEGER, PARAMETER, PUBLIC :: DWRITE_LINE_SPACING_METHOD  &
      = KIND(DWRITE_LINE_SPACING_METHOD_DEFAULT)
  
  
  ENUM, BIND(C)
    ENUMERATOR :: DWRITE_TRIMMING_GRANULARITY_NONE
    ENUMERATOR :: DWRITE_TRIMMING_GRANULARITY_CHARACTER
    ENUMERATOR :: DWRITE_TRIMMING_GRANULARITY_WORD
  END ENUM
  PUBLIC :: DWRITE_TRIMMING_GRANULARITY_NONE
  PUBLIC :: DWRITE_TRIMMING_GRANULARITY_CHARACTER
  PUBLIC :: DWRITE_TRIMMING_GRANULARITY_WORD
  INTEGER, PARAMETER, PUBLIC :: DWRITE_TRIMMING_GRANULARITY  &
      = KIND(DWRITE_TRIMMING_GRANULARITY_NONE)
  
  ! We've set the kind of the following to C_INT, perhaps it should be 
  ! DWORD - I'm really not sure.  (What it should be is the kind of the 
  ! enumerator, but we don't necessarily know that until after the 
  ! enumerator is defined.)
  !
  ! All the enumerator values are descriptive ascii tags.
  ENUM, BIND(C)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_ALTERNATIVE_FRACTIONS  &
        = INT(z'63726661', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_PETITE_CAPITALS_FROM_CAPITALS  &
        = INT(z'63703263', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_SMALL_CAPITALS_FROM_CAPITALS  &
        = INT(z'63733263', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_CONTEXTUAL_ALTERNATES  &
        = INT(z'746c6163', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_CASE_SENSITIVE_FORMS  &
        = INT(z'65736163', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_GLYPH_COMPOSITION_DECOMPOSITION  &
        = INT(z'706d6363', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_CONTEXTUAL_LIGATURES  &
        = INT(z'67696c63', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_CAPITAL_SPACING  &
        = INT(z'70737063', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_CONTEXTUAL_SWASH  &
        = INT(z'68777363', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_CURSIVE_POSITIONING  &
        = INT(z'73727563', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_DEFAULT  &
        = INT(z'746c6664', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_DISCRETIONARY_LIGATURES  &
        = INT(z'67696c64', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_EXPERT_FORMS  &
        = INT(z'74707865', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_FRACTIONS  &
        = INT(z'63617266', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_FULL_WIDTH  &
        = INT(z'64697766', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_HALF_FORMS  &
        = INT(z'666c6168', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_HALANT_FORMS  &
        = INT(z'6e6c6168', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_ALTERNATE_HALF_WIDTH  &
        = INT(z'746c6168', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_HISTORICAL_FORMS  &
        = INT(z'74736968', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_HORIZONTAL_KANA_ALTERNATES  &
        = INT(z'616e6b68', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_HISTORICAL_LIGATURES  &
        = INT(z'67696c68', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_HALF_WIDTH  &
        = INT(z'64697768', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_HOJO_KANJI_FORMS  &
        = INT(z'6f6a6f68', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_JIS04_FORMS  &
        = INT(z'3430706a', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_JIS78_FORMS  &
        = INT(z'3837706a', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_JIS83_FORMS  &
        = INT(z'3338706a', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_JIS90_FORMS  &
        = INT(z'3039706a', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_KERNING  &
        = INT(z'6e72656b', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_STANDARD_LIGATURES  &
        = INT(z'6167696c', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_LINING_FIGURES  &
        = INT(z'6d756e6c', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_LOCALIZED_FORMS  &
        = INT(z'6c636f6c', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_MARK_POSITIONING  &
        = INT(z'6b72616d', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_MATHEMATICAL_GREEK  &
        = INT(z'6b72676d', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_MARK_TO_MARK_POSITIONING  &
        = INT(z'6b6d6b6d', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_ALTERNATE_ANNOTATION_FORMS  &
        = INT(z'746c616e', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_NLC_KANJI_FORMS  &
        = INT(z'6b636c6e', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_OLD_STYLE_FIGURES  &
        = INT(z'6d756e6f', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_ORDINALS  &
        = INT(z'6e64726f', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_PROPORTIONAL_ALTERNATE_WIDTH  &
        = INT(z'746c6170', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_PETITE_CAPITALS  &
        = INT(z'70616370', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_PROPORTIONAL_FIGURES  &
        = INT(z'6d756e70', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_PROPORTIONAL_WIDTHS  &
        = INT(z'64697770', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_QUARTER_WIDTHS  &
        = INT(z'64697771', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_REQUIRED_LIGATURES  &
        = INT(z'67696c72', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_RUBY_NOTATION_FORMS  &
        = INT(z'79627572', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_ALTERNATES  &
        = INT(z'746c6173', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_SCIENTIFIC_INFERIORS  &
        = INT(z'666e6973', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_SMALL_CAPITALS  &
        = INT(z'70636d73', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_SIMPLIFIED_FORMS  &
        = INT(z'6c706d73', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_1  &
        = INT(z'31307373', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_2  &
        = INT(z'32307373', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_3  &
        = INT(z'33307373', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_4  &
        = INT(z'34307373', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_5  &
        = INT(z'35307373', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_6  &
        = INT(z'36307373', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_7  &
        = INT(z'37307373', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_8  &
        = INT(z'38307373', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_9  &
        = INT(z'39307373', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_10  &
        = INT(z'30317373', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_11  &
        = INT(z'31317373', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_12  &
        = INT(z'32317373', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_13  &
        = INT(z'33317373', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_14  &
        = INT(z'34317373', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_15  &
        = INT(z'35317373', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_16  &
        = INT(z'36317373', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_17  &
        = INT(z'37317373', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_18  &
        = INT(z'38317373', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_19  &
        = INT(z'39317373', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_20  &
        = INT(z'30327373', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_SUBSCRIPT  &
        = INT(z'73627573', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_SUPERSCRIPT  &
        = INT(z'73707573', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_SWASH  &
        = INT(z'68737773', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_TITLING  &
        = INT(z'6c746974', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_TRADITIONAL_NAME_FORMS  &
        = INT(z'6d616e74', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_TABULAR_FIGURES  &
        = INT(z'6d756e74', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_TRADITIONAL_FORMS  &
        = INT(z'64617274', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_THIRD_WIDTHS  &
        = INT(z'64697774', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_UNICASE  &
        = INT(z'63696e75', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_VERTICAL_WRITING  &
        = INT(z'74726576', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_VERTICAL_ALTERNATES_AND_ROTATION  &
        = INT(z'32747276', C_INT)
    ENUMERATOR :: DWRITE_FONT_FEATURE_TAG_SLASHED_ZERO  &
        = INT(z'6f72657a', C_INT)
  END ENUM
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_ALTERNATIVE_FRACTIONS
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_PETITE_CAPITALS_FROM_CAPITALS
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_SMALL_CAPITALS_FROM_CAPITALS
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_CONTEXTUAL_ALTERNATES
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_CASE_SENSITIVE_FORMS
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_GLYPH_COMPOSITION_DECOMPOSITION
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_CONTEXTUAL_LIGATURES
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_CAPITAL_SPACING
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_CONTEXTUAL_SWASH
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_CURSIVE_POSITIONING
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_DEFAULT
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_DISCRETIONARY_LIGATURES
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_EXPERT_FORMS
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_FRACTIONS
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_FULL_WIDTH
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_HALF_FORMS
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_HALANT_FORMS
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_ALTERNATE_HALF_WIDTH
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_HISTORICAL_FORMS
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_HORIZONTAL_KANA_ALTERNATES
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_HISTORICAL_LIGATURES
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_HALF_WIDTH
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_HOJO_KANJI_FORMS
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_JIS04_FORMS
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_JIS78_FORMS
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_JIS83_FORMS
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_JIS90_FORMS
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_KERNING
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_STANDARD_LIGATURES
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_LINING_FIGURES
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_LOCALIZED_FORMS
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_MARK_POSITIONING
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_MATHEMATICAL_GREEK
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_MARK_TO_MARK_POSITIONING
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_ALTERNATE_ANNOTATION_FORMS
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_NLC_KANJI_FORMS
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_OLD_STYLE_FIGURES
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_ORDINALS
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_PROPORTIONAL_ALTERNATE_WIDTH
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_PETITE_CAPITALS
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_PROPORTIONAL_FIGURES
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_PROPORTIONAL_WIDTHS
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_QUARTER_WIDTHS
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_REQUIRED_LIGATURES
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_RUBY_NOTATION_FORMS
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_ALTERNATES
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_SCIENTIFIC_INFERIORS
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_SMALL_CAPITALS
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_SIMPLIFIED_FORMS
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_1
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_2
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_3
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_4
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_5
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_6
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_7
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_8
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_9
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_10
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_11
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_12
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_13
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_14
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_15
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_16
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_17
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_18
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_19
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_20
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_SUBSCRIPT
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_SUPERSCRIPT
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_SWASH
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_TITLING
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_TRADITIONAL_NAME_FORMS
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_TABULAR_FIGURES
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_TRADITIONAL_FORMS
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_THIRD_WIDTHS
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_UNICASE
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_VERTICAL_WRITING
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_VERTICAL_ALTERNATES_AND_ROTATION
  PUBLIC :: DWRITE_FONT_FEATURE_TAG_SLASHED_ZERO
  INTEGER, PARAMETER, PUBLIC :: DWRITE_FONT_FEATURE_TAG  &
      = KIND(DWRITE_FONT_FEATURE_TAG_ALTERNATIVE_FRACTIONS)
  
  
  TYPE, BIND(C), PUBLIC :: DWRITE_TEXT_RANGE
    INTEGER(UINT32) :: startPosition
    INTEGER(UINT32) :: length
  END TYPE DWRITE_TEXT_RANGE
  
  
  TYPE, BIND(C), PUBLIC :: DWRITE_FONT_FEATURE
    INTEGER(DWRITE_FONT_FEATURE_TAG) :: nameTag
    INTEGER(UINT32) :: parameter
  END TYPE DWRITE_FONT_FEATURE
  
  
  TYPE, BIND(C), PUBLIC :: DWRITE_TYPOGRAPHIC_FEATURES
    TYPE(C_PTR) :: features     ! pointer to int array, size featureCount.
    INTEGER(UINT32) :: featureCount
  END TYPE DWRITE_TYPOGRAPHIC_FEATURES
  
  
  TYPE, BIND(C), PUBLIC :: DWRITE_TRIMMING
    INTEGER(DWRITE_TRIMMING_GRANULARITY) :: granularity
    INTEGER(UINT32) :: delimiter
    INTEGER(UINT32) :: delimiterCount
  END TYPE DWRITE_TRIMMING
  
  
  ! Forward declarations of IDWriteTypography and IDWriteInlineObject elided.
  
  !-----------------------------------------------------------------------------
  ! "9c906818-31d7-4fd3-a151-7c5e225db55a"  IDWriteTextFormat
  
  TYPE, BIND(C) :: IDWriteTextFormatVTbl
    TYPE(IUnknownVTbl) :: Base
    TYPE(C_FUNPTR) :: SetTextAlignment
    TYPE(C_FUNPTR) :: SetParagraphAlignment
    TYPE(C_FUNPTR) :: SetWordWrapping
    TYPE(C_FUNPTR) :: SetReadingDirection
    TYPE(C_FUNPTR) :: SetFlowDirection
    TYPE(C_FUNPTR) :: SetIncrementalTabStop
    TYPE(C_FUNPTR) :: SetTrimming
    TYPE(C_FUNPTR) :: SetLineSpacing
    TYPE(C_FUNPTR) :: GetTextAlignment
    TYPE(C_FUNPTR) :: GetParagraphAlignment
    TYPE(C_FUNPTR) :: GetWordWrapping
    TYPE(C_FUNPTR) :: GetReadingDirection
    TYPE(C_FUNPTR) :: GetFlowDirection
    TYPE(C_FUNPTR) :: GetIncrementalTabStop
    TYPE(C_FUNPTR) :: GetTrimming
    TYPE(C_FUNPTR) :: GetLineSpacing
    TYPE(C_FUNPTR) :: GetFontCollection
    TYPE(C_FUNPTR) :: GetFontFamilyNameLength
    TYPE(C_FUNPTR) :: GetFontFamilyName
    TYPE(C_FUNPTR) :: GetFontWeight
    TYPE(C_FUNPTR) :: GetFontStyle
    TYPE(C_FUNPTR) :: GetFontStretch
    TYPE(C_FUNPTR) :: GetFontSize
    TYPE(C_FUNPTR) :: GetLocaleNameLength
    TYPE(C_FUNPTR) :: GetLocaleName
  END TYPE IDWriteTextFormatVTbl
  
  ABSTRACT INTERFACE
    FUNCTION SetTextAlignment_intf(this, textAlignment)
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: DWRITE_TEXT_ALIGNMENT
      IMPORT :: HRESULT
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      INTEGER(DWRITE_TEXT_ALIGNMENT), INTENT(IN) :: textAlignment
      INTEGER(HRESULT) :: SetTextAlignment_intf
      !DEC$ ATTRIBUTES STDCALL :: SetTextAlignment_intf
    END FUNCTION SetTextAlignment_intf
    
    FUNCTION SetParagraphAlignment_intf(this, paragraphAlignment)
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: DWRITE_PARAGRAPH_ALIGNMENT
      IMPORT :: HRESULT
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      INTEGER(DWRITE_PARAGRAPH_ALIGNMENT), INTENT(IN) :: paragraphAlignment
      INTEGER(HRESULT) :: SetParagraphAlignment_intf
      !DEC$ ATTRIBUTES STDCALL :: SetParagraphAlignment_intf
    END FUNCTION SetParagraphAlignment_intf
    
    FUNCTION SetWordWrapping_intf(this, wordWrapping)
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: DWRITE_WORD_WRAPPING
      IMPORT :: HRESULT
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      INTEGER(DWRITE_WORD_WRAPPING), INTENT(IN) :: wordWrapping
      INTEGER(HRESULT) :: SetWordWrapping_intf
      !DEC$ ATTRIBUTES STDCALL :: SetWordWrapping_intf
    END FUNCTION SetWordWrapping_intf
    
    !SetReadingDirection
    !SetFlowDirection
    !SetIncrementalTabStop
    !SetTrimming
    !SetLineSpacing
    
    FUNCTION GetTextAlignment_intf(this)
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: DWRITE_TEXT_ALIGNMENT
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      INTEGER(DWRITE_TEXT_ALIGNMENT) :: GetTextAlignment_intf
      !DEC$ ATTRIBUTES STDCALL :: GetTextAlignment_intf
    END FUNCTION GetTextAlignment_intf
    
    FUNCTION GetParagraphAlignment_intf(this)
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: DWRITE_PARAGRAPH_ALIGNMENT
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      INTEGER(DWRITE_PARAGRAPH_ALIGNMENT) :: GetParagraphAlignment_intf
      !DEC$ ATTRIBUTES STDCALL :: GetParagraphAlignment_intf
    END FUNCTION GetParagraphAlignment_intf
    
    FUNCTION GetWordWrapping_intf(this)
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: DWRITE_WORD_WRAPPING
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      INTEGER(DWRITE_WORD_WRAPPING) :: GetWordWrapping_intf
      !DEC$ ATTRIBUTES STDCALL :: GetWordWrapping_intf
    END FUNCTION GetWordWrapping_intf
    
    !GetReadingDirection
    !GetFlowDirection
    !GetIncrementalTabStop
    !GetTrimming
    !GetLineSpacing
    !GetFontCollection
    !GetFontFamilyNameLength
    !GetFontFamilyName
    !GetFontWeight
    !GetFontStyle
    !GetFontStretch
    !GetFontSize
    !GetLocaleNameLength
    !GetLocaleName
  END INTERFACE
  
  TYPE, EXTENDS(IUnknown), PUBLIC :: IDWriteTextFormat
  CONTAINS
    PROCEDURE, NOPASS :: IID => textformat_IID
  END TYPE IDWriteTextFormat
  
  PUBLIC :: SetTextAlignment
  PUBLIC :: SetParagraphAlignment
  PUBLIC :: SetWordWrapping
  
  PUBLIC :: GetTextAlignment
  PUBLIC :: GetParagraphAlignment
  PUBLIC :: GetWordWrapping
  
  !-----------------------------------------------------------------------------
  ! "55f1112b-1dc2-4b3c-9541-f46894ed85b6"  IDWriteTypography
  
  TYPE, EXTENDS(IUnknown) :: IDWriteTypography
  CONTAINS
    PROCEDURE, NOPASS :: IID => typography_IID
  END TYPE IDWriteTypography
  
  !-----------------------------------------------------------------------------
  
  ENUM, BIND(C)
    ENUMERATOR :: DWRITE_SCRIPT_SHAPES_DEFAULT = 0
    ENUMERATOR :: DWRITE_SCRIPT_SHAPES_NO_VISUAL = 1
  END ENUM
  PUBLIC :: DWRITE_SCRIPT_SHAPES_DEFAULT
  PUBLIC :: DWRITE_SCRIPT_SHAPES_NO_VISUAL
  INTEGER, PARAMETER, PUBLIC :: DWRITE_SCRIPT_SHAPES  &
      = KIND(DWRITE_SCRIPT_SHAPES_DEFAULT)
  
  
  TYPE, BIND(C), PUBLIC :: DWRITE_SCRIPT_ANALYSIS
    INTEGER(UINT16) :: script
    INTEGER(DWRITE_SCRIPT_SHAPES) :: shapes
  END TYPE DWRITE_SCRIPT_ANALYSIS
  
  
  ENUM, BIND(C)
    ENUMERATOR :: DWRITE_BREAK_CONDITION_NEUTRAL
    ENUMERATOR :: DWRITE_BREAK_CONDITION_CAN_BREAK
    ENUMERATOR :: DWRITE_BREAK_CONDITION_MAY_NOT_BREAK
    ENUMERATOR :: DWRITE_BREAK_CONDITION_MUST_BREAK
  END ENUM
  PUBLIC :: DWRITE_BREAK_CONDITION_NEUTRAL
  PUBLIC :: DWRITE_BREAK_CONDITION_CAN_BREAK
  PUBLIC :: DWRITE_BREAK_CONDITION_MAY_NOT_BREAK
  PUBLIC :: DWRITE_BREAK_CONDITION_MUST_BREAK
  INTEGER, PARAMETER, PUBLIC :: DWRITE_BREAK_CONDITION  &
      = KIND(DWRITE_BREAK_CONDITION_NEUTRAL)
  
  
  TYPE, BIND(C), PUBLIC :: DWRITE_LINE_BREAKPOINT
    INTEGER(UINT8) :: bitfield
  END TYPE DWRITE_LINE_BREAKPOINT
  
  
  ENUM, BIND(C)
    ENUMERATOR :: DWRITE_NUMBER_SUBSTITUTION_METHOD_FROM_CULTURE
    ENUMERATOR :: DWRITE_NUMBER_SUBSTITUTION_METHOD_CONTEXTUAL
    ENUMERATOR :: DWRITE_NUMBER_SUBSTITUTION_METHOD_NONE
    ENUMERATOR :: DWRITE_NUMBER_SUBSTITUTION_METHOD_NATIONAL
    ENUMERATOR :: DWRITE_NUMBER_SUBSTITUTION_METHOD_TRADITIONAL
  END ENUM
  PUBLIC :: DWRITE_NUMBER_SUBSTITUTION_METHOD_FROM_CULTURE
  PUBLIC :: DWRITE_NUMBER_SUBSTITUTION_METHOD_CONTEXTUAL
  PUBLIC :: DWRITE_NUMBER_SUBSTITUTION_METHOD_NONE
  PUBLIC :: DWRITE_NUMBER_SUBSTITUTION_METHOD_NATIONAL
  PUBLIC :: DWRITE_NUMBER_SUBSTITUTION_METHOD_TRADITIONAL
  INTEGER, PARAMETER, PUBLIC :: DWRITE_NUMBER_SUBSTITUTION_METHOD  &
       = KIND(DWRITE_NUMBER_SUBSTITUTION_METHOD_FROM_CULTURE)
  
  
  !-----------------------------------------------------------------------------
  ! "14885CC9-BAB0-4f90-B6ED-5C366A2CD03D"  IDWriteNumberSubstitution
  
  TYPE, EXTENDS(IUnknown) :: IDWriteNumberSubstitution
  CONTAINS
    PROCEDURE, NOPASS :: IID => numbersubstitution_IID
  END TYPE IDWriteNumberSubstitution
  
  !-----------------------------------------------------------------------------
  
  
  TYPE, BIND(C), PUBLIC :: DWRITE_SHAPING_TEXT_PROPERTIES
    INTEGER(UINT16) :: bitfield
  END TYPE DWRITE_SHAPING_TEXT_PROPERTIES
  
  
  TYPE, BIND(C), PUBLIC :: DWRITE_SHAPING_GLYPH_PROPERTIES
    INTEGER(UINT16) :: bitfield
  END TYPE DWRITE_SHAPING_GLYPH_PROPERTIES
  
  
  !-----------------------------------------------------------------------------
  ! "688e1a58-5094-47c8-adc8-fbcea60ae92b"  IDWriteTextAnalysisSource
  
  TYPE, EXTENDS(IUnknown) :: IDWriteTextAnalysisSource
  CONTAINS
    PROCEDURE, NOPASS :: IID => textanalysissource_IID
  END TYPE IDWriteTextAnalysisSource
  
  !-----------------------------------------------------------------------------
  ! "5810cd44-0ca0-4701-b3fa-bec5182ae4f6"  IDWriteTextAnalysisSink
  
  TYPE, EXTENDS(IUnknown) :: IDWriteTextAnalysisSink
  CONTAINS
    PROCEDURE, NOPASS :: IID => textanalysissink_IID
  END TYPE IDWriteTextAnalysisSink
  
  !-----------------------------------------------------------------------------
  ! "b7e6163e-7f46-43b4-84b3-e4e6249c365d"  IDWriteTextAnalyzer
  
  TYPE, EXTENDS(IUnknown) :: IDWriteTextAnalyzer
  CONTAINS
    PROCEDURE, NOPASS :: IID => textanalyzer_IID
  END TYPE IDWriteTextAnalyzer
  
  !-----------------------------------------------------------------------------
  
  
  TYPE, BIND(C), PUBLIC :: DWRITE_GLYPH_RUN
    TYPE(C_PTR) :: fontFace         ! IDWriteFontFace*
    REAL(FLOAT) :: fontEmSize
    INTEGER(UINT32) :: glyphCount
    TYPE(C_PTR) :: glyphIndices     ! UINT16 const* glyphIndices
    TYPE(C_PTR) :: gluphAdvances    ! FLOAT const* glyphAdvances
    TYPE(C_PTR) :: glyphOffsets     ! DWRITE_GLYPH_OFFSET const* glyphOffsets
    INTEGER(BOOL) :: isSideways
    INTEGER(UINT32) :: bidiLevel
  END TYPE DWRITE_GLYPH_RUN
  
  
  TYPE, BIND(C), PUBLIC :: DWRITE_GLYPH_RUN_DESCRIPTION
    TYPE(C_PTR) :: localName        ! WCHAR const*
    TYPE(C_PTR) :: string           ! WCHAR const*
    INTEGER(UINT32) :: stringLength
    TYPE(C_PTR) :: clusterMap       ! UINT16 const*
    INTEGER(UINT32) :: textPosition
  END TYPE DWRITE_GLYPH_RUN_DESCRIPTION
  
  
  TYPE, BIND(C), PUBLIC :: DWRITE_UNDERLINE
    REAL(FLOAT) :: width
    REAL(FLOAT) :: thickness
    REAL(FLOAT) :: offset
    REAL(FLOAT) :: runHeight
    INTEGER(DWRITE_READING_DIRECTION) :: readingDirection
    INTEGER(DWRITE_FLOW_DIRECTION) :: flowDirection
    TYPE(C_PTR) :: localName        ! WCHAR const*
    INTEGER(DWRITE_MEASURING_MODE) :: measuringMode
  END TYPE DWRITE_UNDERLINE
  
  
  TYPE, BIND(C), PUBLIC :: DWRITE_STRIKETHROUGH
    REAL(FLOAT) :: width
    REAL(FLOAT) :: thickness
    REAL(FLOAT) :: offset
    INTEGER(DWRITE_READING_DIRECTION) :: readingDirection
    INTEGER(DWRITE_FLOW_DIRECTION) :: flowDirection
    TYPE(C_PTR) :: localName        ! WCHAR const*
    INTEGER(DWRITE_MEASURING_MODE) :: measuringMode
  END TYPE DWRITE_STRIKETHROUGH
  
  
  TYPE, BIND(C), PUBLIC :: DWRITE_LINE_METRICS
    INTEGER(UINT32) :: length
    INTEGER(UINT32) :: trailingWhitespaceLength
    INTEGER(UINT32) :: newlineLength
    REAL(FLOAT) :: height
    REAL(FLOAT) :: baseline
    REAL(FLOAT) :: isTrimmed
  END TYPE DWRITE_LINE_METRICS
  
  
  TYPE, BIND(C), PUBLIC :: DWRITE_CLUSTER_METRICS
    REAL(FLOAT) :: width
    INTEGER(UINT16) :: length
    INTEGER(UINT16) :: bitfield     ! Need some parameters for this.
  END TYPE DWRITE_CLUSTER_METRICS
  
  
  TYPE, BIND(C), PUBLIC :: DWRITE_TEXT_METRICS
    REAL(FLOAT) :: left
    REAL(FLOAT) :: top
    REAL(FLOAT) :: width
    REAL(FLOAT) :: widthIncludingTrailingWhitespace
    REAL(FLOAT) :: height
    REAL(FLOAT) :: layoutWidth
    REAL(FLOAT) :: layoutHeight
    INTEGER(UINT32) :: maxBidiReorderingDepth
    INTEGER(UINT32) :: lineCount
  END TYPE DWRITE_TEXT_METRICS
  
  
  TYPE, BIND(C), PUBLIC :: DWRITE_INLINE_OBJECT_METRICS
    REAL(FLOAT) :: width
    REAL(FLOAT) :: height
    REAL(FLOAT) :: baseline
    INTEGER(BOOL) :: supportsSideways
  END TYPE DWRITE_INLINE_OBJECT_METRICS
  
  
  TYPE, BIND(C), PUBLIC :: DWRITE_OVERHANG_METRICS
    REAL(FLOAT) :: left
    REAL(FLOAT) :: top
    REAL(FLOAT) :: right
    REAL(FLOAT) :: bottom
  END TYPE DWRITE_OVERHANG_METRICS
  
  TYPE, BIND(C), PUBLIC :: DWRITE_HIT_TEST_METRICS
    INTEGER(UINT32) :: textPosition
    INTEGER(UINT32) :: length
    REAL(FLOAT) :: left
    REAL(FLOAT) :: top
    REAL(FLOAT) :: width
    REAL(FLOAT) :: height
    INTEGER(UINT32) :: bidiLevel
    INTEGER(BOOL) :: isText
    INTEGER(BOOL) :: isTrimmed
  END TYPE DWRITE_HIT_TEST_METRICS
  
  
  ! Forward declaration of IDWriteTextRenderer elided.
  
  !-----------------------------------------------------------------------------
  ! "8339FDE3-106F-47ab-8373-1C6295EB10B3"  IDWriteInlineObject
  
  TYPE, EXTENDS(IUnknown) :: IDWriteInlineObject
  CONTAINS
    PROCEDURE, NOPASS :: IID => inlineobject_IID
  END TYPE IDWriteInlineObject
  
  !-----------------------------------------------------------------------------
  ! "eaf3a2da-ecf4-4d24-b644-b34f6842024b"  IDWritePixelSnapping
  
  TYPE, EXTENDS(IUnknown) :: IDWritePixelSnapping
  CONTAINS
    PROCEDURE, NOPASS :: IID => pixelsnapping_IID
  END TYPE IDWritePixelSnapping
  
  !-----------------------------------------------------------------------------
  ! "ef8a8135-5cc6-45fe-8825-c5a0724eb819"  IDWriteTextRenderer
  
  TYPE, EXTENDS(IDWritePixelSnapping) :: IDWriteTextRenderer
  CONTAINS
    PROCEDURE, NOPASS :: IID => renderer_IID
  END TYPE IDWriteTextRenderer
  
  !-----------------------------------------------------------------------------
  ! "53737037-6d14-410b-9bfe-0b182bb70961"  IDWriteTextLayout
  
  TYPE, BIND(C) :: IDWriteTextLayoutVTbl
    TYPE(IDWriteTextFormatVTbl) :: Base
    TYPE(C_FUNPTR) :: SetMaxWidth
    TYPE(C_FUNPTR) :: SetMaxHeight
    TYPE(C_FUNPTR) :: SetFontCollection
    TYPE(C_FUNPTR) :: SetFontFamilyName
    TYPE(C_FUNPTR) :: SetFontWeight
    TYPE(C_FUNPTR) :: SetFontStyle
    TYPE(C_FUNPTR) :: SetFontStretch
    TYPE(C_FUNPTR) :: SetFontSize
    TYPE(C_FUNPTR) :: SetUnderline
    TYPE(C_FUNPTR) :: SetStrikethrough
    TYPE(C_FUNPTR) :: SetDrawingEffect
    TYPE(C_FUNPTR) :: SetInlineObject
    TYPE(C_FUNPTR) :: SetTypography
    TYPE(C_FUNPTR) :: SetLocaleName
    TYPE(C_FUNPTR) :: GetMaxWidth
    TYPE(C_FUNPTR) :: GetMaxHeight
    TYPE(C_FUNPTR) :: GetFontCollection
    TYPE(C_FUNPTR) :: GetFontFamilyNameLength
    TYPE(C_FUNPTR) :: GetFontFamilyName
    TYPE(C_FUNPTR) :: GetFontWeight
    TYPE(C_FUNPTR) :: GetFontStyle
    TYPE(C_FUNPTR) :: GetFontStretch
    TYPE(C_FUNPTR) :: GetFontSize
    TYPE(C_FUNPTR) :: GetUnderline
    TYPE(C_FUNPTR) :: GetStrikethrough
    TYPE(C_FUNPTR) :: GetDrawingEffect
    TYPE(C_FUNPTR) :: GetInlineObject
    TYPE(C_FUNPTR) :: GetTypography
    TYPE(C_FUNPTR) :: GetLocaleNameLength
    TYPE(C_FUNPTR) :: GetLocaleName
    TYPE(C_FUNPTR) :: Draw
    TYPE(C_FUNPTR) :: GetLineMetrics
    TYPE(C_FUNPTR) :: GetMetrics
    TYPE(C_FUNPTR) :: GetOverhangMetrics
    TYPE(C_FUNPTR) :: GetClusterMetrics
    TYPE(C_FUNPTR) :: DetermineMinWidth
    TYPE(C_FUNPTR) :: HitTestPoint
    TYPE(C_FUNPTR) :: HitTestTextPosition
    TYPE(C_FUNPTR) :: HitTestTextRange
  END TYPE IDWriteTextLayoutVTbl
  
  ABSTRACT INTERFACE
    !SetMaxWidth  
    !SetMaxHeight  
    !SetFontCollection  
    !SetFontFamilyName  
    !SetFontWeight  
    !SetFontStyle  
    !SetFontStretch  
    !SetFontSize  
    !SetUnderline  
    !SetStrikethrough  
    !SetDrawingEffect  
    !SetInlineObject  
    !SetTypography  
    !SetLocaleName  
    !GetMaxWidth  
    !GetMaxHeight  
    !GetFontCollection  
    !GetFontFamilyNameLength  
    !GetFontFamilyName  
    !GetFontWeight  
    !GetFontStyle  
    !GetFontStretch  
    !GetFontSize  
    !GetUnderline  
    !GetStrikethrough  
    !GetDrawingEffect  
    !GetInlineObject  
    !GetTypography  
    !GetLocaleNameLength  
    !GetLocaleName  
    !Draw  
    !GetLineMetrics  
    
    FUNCTION GetMetrics_intf(this, textMetrics)
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: DWRITE_TEXT_METRICS
      IMPORT :: HRESULT
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      TYPE(DWRITE_TEXT_METRICS), INTENT(OUT) :: textMetrics
      !DEC$ ATTRIBUTES REFERENCE :: textMetrics
      INTEGER(HRESULT) :: GetMetrics_intf
      !DEC$ ATTRIBUTES STDCALL :: GetMetrics_intf
    END FUNCTION GetMetrics_intf
    
    !GetOverhangMetrics  
    !GetClusterMetrics  
    
    FUNCTION DetermineMinWidth_intf(this, minWidth)
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: FLOAT
      IMPORT :: HRESULT
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      REAL(FLOAT), INTENT(OUT) :: minWidth
      !DEC$ ATTRIBUTES REFERENCE :: minWidth
      INTEGER(HRESULT) :: DetermineMinWidth_intf
      !DEC$ ATTRIBUTES STDCALL :: DetermineMinWidth_intf
    END FUNCTION DetermineMinWidth_intf
    
    !DetermineMinWidth  
    !HitTestPoint  
    !HitTestTextPosition  
    !HitTestTextRange  
  END INTERFACE
  
  TYPE, EXTENDS(IDWriteTextFormat), PUBLIC :: IDWriteTextLayout
  CONTAINS
    PROCEDURE, NOPASS :: IID => textlayout_IID
  END TYPE IDWriteTextLayout
  
  PUBLIC :: GetMetrics
  PUBLIC :: DetermineMinWidth
  
  !-----------------------------------------------------------------------------
  ! "5e5a32a3-8dff-4773-9ff6-0696eab77267"  IDWriteBitmapRenderTarget
  
  TYPE, EXTENDS(IUnknown) :: IDWriteBitmapRenderTarget
  CONTAINS
    PROCEDURE, NOPASS :: IID => bitmaprendertarget_IID
  END TYPE IDWriteBitmapRenderTarget
  
  !-----------------------------------------------------------------------------
  ! "1edd9491-9853-4299-898f-6432983b6f3a"  IDWriteGdiInterop
  
  TYPE, EXTENDS(IUnknown) :: IDWriteGdiInterop
  CONTAINS
    PROCEDURE, NOPASS :: IID => gdiinterop_IID
  END TYPE IDWriteGdiInterop
  
  !-----------------------------------------------------------------------------
  
  ENUM, BIND(C)
    ENUMERATOR :: DWRITE_TEXTURE_ALIASED_1x1
    ENUMERATOR :: DWRITE_TEXTURE_CLEARTYPE_3x1
  END ENUM
  PUBLIC :: DWRITE_TEXTURE_ALIASED_1x1
  PUBLIC :: DWRITE_TEXTURE_CLEARTYPE_3x1
  INTEGER, PARAMETER, PUBLIC :: DWRITE_TEXTURE_TYPE  &
       = KIND(DWRITE_TEXTURE_ALIASED_1x1)
  
  
  INTEGER, PARAMETER, PUBLIC :: DWRITE_ALPHA_MAX = 255
  
  !-----------------------------------------------------------------------------
  ! "7d97dbf7-e085-42d4-81e3-6a883bded118"  IDWriteGlyphRunAnalysis
  
  TYPE, EXTENDS(IUnknown) :: IDWriteGlyphRunAnalysis
  CONTAINS
    PROCEDURE, NOPASS :: IID => glyphrunanalysis_IID
  END TYPE IDWriteGlyphRunAnalysis
  
  !-----------------------------------------------------------------------------
  ! "b859ee5a-d838-4b5b-a2e8-1adc7d93db48" IDWriteFactory
  
  TYPE, BIND(C) :: IDWriteFactoryVTbl
    TYPE(IUnknownVTbl) :: Base
    TYPE(C_FUNPTR) :: GetSystemFontCollection
    TYPE(C_FUNPTR) :: CreateCustomFontCollection
    TYPE(C_FUNPTR) :: RegisterFontCollectionLoader
    TYPE(C_FUNPTR) :: UnregisterFontCollectionLoader
    TYPE(C_FUNPTR) :: CreateFontFileReference
    TYPE(C_FUNPTR) :: CreateCustomFontFileReference
    TYPE(C_FUNPTR) :: CreateFontFace
    TYPE(C_FUNPTR) :: CreateRenderingParams
    TYPE(C_FUNPTR) :: CreateMonitorRenderingParams
    TYPE(C_FUNPTR) :: CreateCustomRenderingParams
    TYPE(C_FUNPTR) :: RegisterFontFileLoader
    TYPE(C_FUNPTR) :: UnregisterFontFileLoader
    TYPE(C_FUNPTR) :: CreateTextFormat
    TYPE(C_FUNPTR) :: CreateTypography
    TYPE(C_FUNPTR) :: GetGdiInterop
    TYPE(C_FUNPTR) :: CreateTextLayout
    TYPE(C_FUNPTR) :: CreateGdiCompatibleTextLayout
    TYPE(C_FUNPTR) :: CreateEllipsisTrimmingSign
    TYPE(C_FUNPTR) :: CreateTextAnalyzer
    TYPE(C_FUNPTR) :: CreateNumberSubstitution
    TYPE(C_FUNPTR) :: CreateGlyphRunAnalysis
  END TYPE IDWriteFactoryVTbl
  
  ABSTRACT INTERFACE
    !GetSystemFontCollection
    !CreateCustomFontCollection
    !RegisterFontCollectionLoader
    !UnregisterFontCollectionLoader
    !CreateFontFileReference
    !CreateCustomFontFileReference
    !CreateFontFace
    !CreateRenderingParams
    !CreateMonitorRenderingParams
    !CreateCustomRenderingParams
    !RegisterFontFileLoader
    !UnregisterFontFileLoader
    
    FUNCTION CreateTextFormat_intf( this, fontFamilyName, fontCollection,  &
        fontWeight, fontStyle, fontStretch, fontSize, localeName,  &
        textFormat )
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: WCHAR
      IMPORT :: DWRITE_FONT_WEIGHT
      IMPORT :: DWRITE_FONT_STYLE
      IMPORT :: DWRITE_FONT_STRETCH
      IMPORT :: FLOAT
      IMPORT :: HRESULT
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      INTEGER(WCHAR), INTENT(IN) :: fontFamilyName(*)
      TYPE(C_PTR), INTENT(IN) :: fontCollection
      INTEGER(DWRITE_FONT_WEIGHT), INTENT(IN) :: fontWeight
      INTEGER(DWRITE_FONT_STYLE), INTENT(IN) :: fontStyle
      INTEGER(DWRITE_FONT_STRETCH), INTENT(IN) :: fontStretch
      REAL(FLOAT), INTENT(IN) :: fontSize
      INTEGER(WCHAR), INTENT(IN) :: localeName(*)
      TYPE(C_PTR), INTENT(OUT) :: textFormat
      !DEC$ ATTRIBUTES REFERENCE :: textFormat
      INTEGER(HRESULT) :: CreateTextFormat_intf
      !DEC$ ATTRIBUTES STDCALL :: CreateTextFormat_intf
    END FUNCTION CreateTextFormat_intf
    
    !CreateTypography
    !GetGdiInterop
    !CreateTextLayout
    
    FUNCTION CreateTextLayout_intf( this, string, stringLength, textFormat,  &
        maxWidth, maxHeight, textLayout )
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR
      IMPORT :: WCHAR
      IMPORT :: UINT32
      IMPORT :: FLOAT
      IMPORT :: HRESULT
      IMPLICIT NONE
      !-------------------------------------------------------------------------
      TYPE(C_PTR), INTENT(IN) :: this
      INTEGER(WCHAR), INTENT(IN) :: string(*)
      INTEGER(UINT32), INTENT(IN) :: stringLength
      TYPE(C_PTR), INTENT(IN) :: textFormat
      REAL(FLOAT), INTENT(IN) :: maxWidth
      REAL(FLOAT), INTENT(IN) :: maxHeight
      TYPE(C_PTR), INTENT(OUT) :: textLayout
      !DEC$ ATTRIBUTES REFERENCE :: textLayout
      INTEGER(HRESULT) :: CreateTextLayout_intf
      !DEC$ ATTRIBUTES STDCALL :: CreateTextLayout_intf
    END FUNCTION CreateTextLayout_intf
    
    !CreateGdiCompatibleTextLayout
    !CreateEllipsisTrimmingSign
    !CreateTextAnalyzer
    !CreateNumberSubstitution
    !CreateGlyphRunAnalysis
  END INTERFACE
  
  TYPE, EXTENDS(IUnknown), PUBLIC :: IDWriteFactory
  CONTAINS
    PROCEDURE, NOPASS :: IID => factory_IID
  END TYPE IDWriteFactory
  
  INTERFACE CreateTextFormat
    MODULE PROCEDURE :: CreateTextFormat_utf8
    MODULE PROCEDURE :: CreateTextFormat_utf16
  END INTERFACE CreateTextFormat
  PUBLIC :: CreateTextFormat
  
  INTERFACE CreateTextLayout
    MODULE PROCEDURE :: CreateTextLayout_utf8
    MODULE PROCEDURE :: CreateTextLayout_utf16
  END INTERFACE CreateTextLayout
  PUBLIC :: CreateTextLayout
  
  !-----------------------------------------------------------------------------
  
  PUBLIC :: DWriteCreateFactory
  
CONTAINS
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Miscelleneous helpers.
  
  
  !*****************************************************************************
  
  ELEMENTAL FUNCTION DWRITE_MAKE_OPENTYPE_TAG(a, b, c, d) RESULT(tag)
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    CHARACTER, INTENT(IN) :: a
    CHARACTER, INTENT(IN) :: b
    CHARACTER, INTENT(IN) :: c
    CHARACTER, INTENT(IN) :: d
    
    INTEGER(UINT32) :: tag
    
    !***************************************************************************
    
    tag = IANY([  &
        SHIFTL(TRANSFER(d, tag), 24),  &
        SHIFTL(TRANSFER(c, tag), 16),  &
        SHIFTL(TRANSFER(b, tag), 8),  &
        TRANSFER(a, tag) ])
    
  END FUNCTION DWRITE_MAKE_OPENTYPE_TAG
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! IDWriteFontFileLoader
  
  
  !*****************************************************************************
  
  FUNCTION fontfileloader_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: fontfileloader_IID
    
    !***************************************************************************
    
    fontfileloader_IID = GUID(  &
        INT(Z'727CAD4E', C_INT32_T),  &
        INT(Z'D6AF', C_INT16_T),  &
        INT(Z'4C9C', C_INT16_T),  &
        [ INT(Z'8A', C_SIGNED_CHAR), INT(Z'08', C_SIGNED_CHAR),  &
          INT(Z'D6', C_SIGNED_CHAR), INT(Z'95', C_SIGNED_CHAR),  &
          INT(Z'B1', C_SIGNED_CHAR), INT(Z'1C', C_SIGNED_CHAR),  &
          INT(Z'AA', C_SIGNED_CHAR), INT(Z'49', C_SIGNED_CHAR) ] )
    
  END FUNCTION fontfileloader_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! DWriteLocalFontFileLoader
  
  
  !*****************************************************************************
  
  FUNCTION localfontfileloader_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: localfontfileloader_IID
    
    !***************************************************************************
    
    localfontfileloader_IID = GUID(  &
        INT(Z'B2D9F3EC', C_INT32_T),  &
        INT(Z'C9FE', C_INT16_T),  &
        INT(Z'4A11', C_INT16_T),  &
        [ INT(Z'A2', C_SIGNED_CHAR), INT(Z'EC', C_SIGNED_CHAR),  &
          INT(Z'D8', C_SIGNED_CHAR), INT(Z'62', C_SIGNED_CHAR),  &
          INT(Z'08', C_SIGNED_CHAR), INT(Z'F7', C_SIGNED_CHAR),  &
          INT(Z'C0', C_SIGNED_CHAR), INT(Z'A2', C_SIGNED_CHAR) ] )
    
  END FUNCTION localfontfileloader_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! DWriteFontFileStream
  
  
  !*****************************************************************************
  
  FUNCTION fontfilestream_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: fontfilestream_IID
    
    !***************************************************************************
    
    fontfilestream_IID = GUID(  &
        INT(Z'644865FE', C_INT32_T),  &
        INT(Z'0AB8', C_INT16_T),  &
        INT(Z'4D91', C_INT16_T),  &
        [ INT(Z'8F', C_SIGNED_CHAR), INT(Z'62', C_SIGNED_CHAR),  &
          INT(Z'5D', C_SIGNED_CHAR), INT(Z'D6', C_SIGNED_CHAR),  &
          INT(Z'BE', C_SIGNED_CHAR), INT(Z'34', C_SIGNED_CHAR),  &
          INT(Z'A3', C_SIGNED_CHAR), INT(Z'E0', C_SIGNED_CHAR) ] )
    
  END FUNCTION fontfilestream_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! DWriteFontFile
  
  
  !*****************************************************************************
  
  FUNCTION fontfile_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: fontfile_IID
    
    !***************************************************************************
    
    fontfile_IID = GUID(  &
        INT(Z'739D886A', C_INT32_T),  &
        INT(Z'CEF5', C_INT16_T),  &
        INT(Z'47DC', C_INT16_T),  &
        [ INT(Z'87', C_SIGNED_CHAR), INT(Z'69', C_SIGNED_CHAR),  &
          INT(Z'1A', C_SIGNED_CHAR), INT(Z'8B', C_SIGNED_CHAR),  &
          INT(Z'41', C_SIGNED_CHAR), INT(Z'BE', C_SIGNED_CHAR),  &
          INT(Z'BB', C_SIGNED_CHAR), INT(Z'B0', C_SIGNED_CHAR) ] )
    
  END FUNCTION fontfile_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! DWriteRenderingParams
  
  
  !*****************************************************************************
  
  FUNCTION renderingparams_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: renderingparams_IID
    
    !***************************************************************************
    
    renderingparams_IID = GUID(  &
        INT(Z'2F0DA53A', C_INT32_T),  &
        INT(Z'2ADD', C_INT16_T),  &
        INT(Z'47CD', C_INT16_T),  &
        [ INT(Z'82', C_SIGNED_CHAR), INT(Z'EE', C_SIGNED_CHAR),  &
          INT(Z'D9', C_SIGNED_CHAR), INT(Z'EC', C_SIGNED_CHAR),  &
          INT(Z'34', C_SIGNED_CHAR), INT(Z'68', C_SIGNED_CHAR),  &
          INT(Z'8E', C_SIGNED_CHAR), INT(Z'75', C_SIGNED_CHAR) ] )
    
  END FUNCTION renderingparams_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! DWriteFontFace
  
  
  !*****************************************************************************
  
  FUNCTION fontface_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: fontface_IID
    
    !***************************************************************************
    
    fontface_IID = GUID(  &
        INT(Z'5F49804D', C_INT32_T),  &
        INT(Z'7024', C_INT16_T),  &
        INT(Z'4D43', C_INT16_T),  &
        [ INT(Z'BF', C_SIGNED_CHAR), INT(Z'A9', C_SIGNED_CHAR),  &
          INT(Z'D2', C_SIGNED_CHAR), INT(Z'59', C_SIGNED_CHAR),  &
          INT(Z'84', C_SIGNED_CHAR), INT(Z'F5', C_SIGNED_CHAR),  &
          INT(Z'38', C_SIGNED_CHAR), INT(Z'49', C_SIGNED_CHAR) ] )
    
  END FUNCTION fontface_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! IDWriteFontCollectionLoader
  
  
  !*****************************************************************************
  
  FUNCTION fontcollectionloader_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: fontcollectionloader_IID
    
    !***************************************************************************
    
    fontcollectionloader_IID = GUID(  &
        INT(Z'CCA920E4', C_INT32_T),  &
        INT(Z'52F0', C_INT16_T),  &
        INT(Z'492B', C_INT16_T),  &
        [ INT(Z'BF', C_SIGNED_CHAR), INT(Z'A8', C_SIGNED_CHAR),  &
          INT(Z'29', C_SIGNED_CHAR), INT(Z'C7', C_SIGNED_CHAR),  &
          INT(Z'2E', C_SIGNED_CHAR), INT(Z'E0', C_SIGNED_CHAR),  &
          INT(Z'A4', C_SIGNED_CHAR), INT(Z'68', C_SIGNED_CHAR) ] )
    
  END FUNCTION fontcollectionloader_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! IDWriteFontFileEnumerator
  
  
  !*****************************************************************************
  
  FUNCTION fontfileenumerator_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: fontfileenumerator_IID
    
    !***************************************************************************
    
    fontfileenumerator_IID = GUID(  &
        INT(Z'72755049', C_INT32_T),  &
        INT(Z'5FF7', C_INT16_T),  &
        INT(Z'435D', C_INT16_T),  &
        [ INT(Z'83', C_SIGNED_CHAR), INT(Z'48', C_SIGNED_CHAR),  &
          INT(Z'4B', C_SIGNED_CHAR), INT(Z'E9', C_SIGNED_CHAR),  &
          INT(Z'7C', C_SIGNED_CHAR), INT(Z'FA', C_SIGNED_CHAR),  &
          INT(Z'6C', C_SIGNED_CHAR), INT(Z'7C', C_SIGNED_CHAR) ] )
    
  END FUNCTION fontfileenumerator_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! IDWriteLocalizedStrings
  
  
  !*****************************************************************************
  
  FUNCTION localizedstrings_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: localizedstrings_IID
    
    !***************************************************************************
    
    localizedstrings_IID = GUID(  &
        INT(Z'08256209', C_INT32_T),  &
        INT(Z'099A', C_INT16_T),  &
        INT(Z'4B34', C_INT16_T),  &
        [ INT(Z'B8', C_SIGNED_CHAR), INT(Z'6D', C_SIGNED_CHAR),  &
          INT(Z'C2', C_SIGNED_CHAR), INT(Z'2B', C_SIGNED_CHAR),  &
          INT(Z'11', C_SIGNED_CHAR), INT(Z'0E', C_SIGNED_CHAR),  &
          INT(Z'77', C_SIGNED_CHAR), INT(Z'71', C_SIGNED_CHAR) ] )
    
  END FUNCTION localizedstrings_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! IDWriteFontCollection
  
  
  !*****************************************************************************
  
  FUNCTION fontcollection_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: fontcollection_IID
    
    !***************************************************************************
    
    fontcollection_IID = GUID(  &
        INT(Z'A84CEE02', C_INT32_T),  &
        INT(Z'3EEA', C_INT16_T),  &
        INT(Z'4EEE', C_INT16_T),  &
        [ INT(Z'A8', C_SIGNED_CHAR), INT(Z'27', C_SIGNED_CHAR),  &
          INT(Z'87', C_SIGNED_CHAR), INT(Z'C1', C_SIGNED_CHAR),  &
          INT(Z'A0', C_SIGNED_CHAR), INT(Z'2A', C_SIGNED_CHAR),  &
          INT(Z'0F', C_SIGNED_CHAR), INT(Z'CC', C_SIGNED_CHAR) ] )
    
  END FUNCTION fontcollection_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! IDWriteFontList
  
  
  !*****************************************************************************
  
  FUNCTION fontlist_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: fontlist_IID
    
    !***************************************************************************
    
    fontlist_IID = GUID(  &
        INT(Z'1A0D8438', C_INT32_T),  &
        INT(Z'1D97', C_INT16_T),  &
        INT(Z'4EC1', C_INT16_T),  &
        [ INT(Z'AE', C_SIGNED_CHAR), INT(Z'F9', C_SIGNED_CHAR),  &
          INT(Z'A2', C_SIGNED_CHAR), INT(Z'FB', C_SIGNED_CHAR),  &
          INT(Z'86', C_SIGNED_CHAR), INT(Z'ED', C_SIGNED_CHAR),  &
          INT(Z'6A', C_SIGNED_CHAR), INT(Z'CB', C_SIGNED_CHAR) ] )
    
  END FUNCTION fontlist_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! IDWriteFontFamily
  
  
  !*****************************************************************************
  
  FUNCTION fontfamily_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: fontfamily_IID
    
    !***************************************************************************
    
    fontfamily_IID = GUID(  &
        INT(Z'DA20D8EF', C_INT32_T),  &
        INT(Z'812A', C_INT16_T),  &
        INT(Z'4C43', C_INT16_T),  &
        [ INT(Z'98', C_SIGNED_CHAR), INT(Z'02', C_SIGNED_CHAR),  &
          INT(Z'62', C_SIGNED_CHAR), INT(Z'EC', C_SIGNED_CHAR),  &
          INT(Z'4A', C_SIGNED_CHAR), INT(Z'BD', C_SIGNED_CHAR),  &
          INT(Z'7A', C_SIGNED_CHAR), INT(Z'DD', C_SIGNED_CHAR) ] )
    
  END FUNCTION fontfamily_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! IDWriteFont
  
  
  !*****************************************************************************
  
  FUNCTION font_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: font_IID
    
    !***************************************************************************
    
    font_IID = GUID(  &
        INT(Z'ACD16696', C_INT32_T),  &
        INT(Z'8C14', C_INT16_T),  &
        INT(Z'4F5D', C_INT16_T),  &
        [ INT(Z'87', C_SIGNED_CHAR), INT(Z'7E', C_SIGNED_CHAR),  &
          INT(Z'FE', C_SIGNED_CHAR), INT(Z'3F', C_SIGNED_CHAR),  &
          INT(Z'C1', C_SIGNED_CHAR), INT(Z'D3', C_SIGNED_CHAR),  &
          INT(Z'27', C_SIGNED_CHAR), INT(Z'37', C_SIGNED_CHAR) ] )
    
  END FUNCTION font_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! IDWriteTextFormat
  
  
  !*****************************************************************************
  
  FUNCTION textformat_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: textformat_IID
    
    !***************************************************************************
    
    textformat_IID = GUID(  &
        INT(Z'9C906818', C_INT32_T),  &
        INT(Z'31D7', C_INT16_T),  &
        INT(Z'4FD3', C_INT16_T),  &
        [ INT(Z'A1', C_SIGNED_CHAR), INT(Z'51', C_SIGNED_CHAR),  &
          INT(Z'7C', C_SIGNED_CHAR), INT(Z'5E', C_SIGNED_CHAR),  &
          INT(Z'22', C_SIGNED_CHAR), INT(Z'5D', C_SIGNED_CHAR),  &
          INT(Z'B5', C_SIGNED_CHAR), INT(Z'5A', C_SIGNED_CHAR) ] )
    
  END FUNCTION textformat_IID
  
  
  !*****************************************************************************
  
  SUBROUTINE SetTextAlignment(textFormat, textAlignment, hr)
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_F_POINTER, C_F_PROCPOINTER
    
    !---------------------------------------------------------------------------
    ! Arguments
    
    CLASS(IDWriteTextFormat), INTENT(INOUT) :: textFormat
    INTEGER(DWRITE_TEXT_ALIGNMENT), INTENT(IN) :: textAlignment
    INTEGER(HRESULT), INTENT(OUT) :: hr
    
    !---------------------------------------------------------------------------
    ! Local variables
    
    TYPE(IDWriteTextFormatVTbl), POINTER :: ptbl
    PROCEDURE(SetTextAlignment_intf), POINTER :: proc
    
    !***************************************************************************
    
    CALL C_F_POINTER(VTable(textFormat), ptbl)
    CALL C_F_PROCPOINTER(ptbl%SetTextAlignment, proc)
    
    hr = proc(textFormat%object, textAlignment)
    
  END SUBROUTINE SetTextAlignment
  
  
  !*****************************************************************************
  
  SUBROUTINE SetParagraphAlignment(textFormat, paragraphAlignment, hr)
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_F_POINTER, C_F_PROCPOINTER
    
    !---------------------------------------------------------------------------
    ! Arguments
    
    CLASS(IDWriteTextFormat), INTENT(INOUT) :: textFormat
    INTEGER(DWRITE_PARAGRAPH_ALIGNMENT), INTENT(IN) :: paragraphAlignment
    INTEGER(HRESULT), INTENT(OUT) :: hr
    
    !---------------------------------------------------------------------------
    ! Local variables
    
    TYPE(IDWriteTextFormatVTbl), POINTER :: ptbl
    PROCEDURE(SetParagraphAlignment_intf), POINTER :: proc
    
    !***************************************************************************
    
    CALL C_F_POINTER(VTable(textFormat), ptbl)
    CALL C_F_PROCPOINTER(ptbl%SetParagraphAlignment, proc)
    
    hr = proc(textFormat%object, paragraphAlignment)
    
  END SUBROUTINE SetParagraphAlignment
  
  
  !*****************************************************************************
  
  SUBROUTINE SetWordWrapping(textFormat, wordWrapping, hr)
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_F_POINTER, C_F_PROCPOINTER
    
    !---------------------------------------------------------------------------
    ! Arguments
    
    CLASS(IDWriteTextFormat), INTENT(INOUT) :: textFormat
    INTEGER(DWRITE_WORD_WRAPPING), INTENT(IN) :: wordWrapping
    INTEGER(HRESULT), INTENT(OUT) :: hr
    
    !---------------------------------------------------------------------------
    ! Local variables
    
    TYPE(IDWriteTextFormatVTbl), POINTER :: ptbl
    PROCEDURE(SetWordWrapping_intf), POINTER :: proc
    
    !***************************************************************************
    
    CALL C_F_POINTER(VTable(textFormat), ptbl)
    CALL C_F_PROCPOINTER(ptbl%SetWordWrapping, proc)
    
    hr = proc(textFormat%object, wordWrapping)
    
  END SUBROUTINE SetWordWrapping
  
  
  !*****************************************************************************
  
  FUNCTION GetTextAlignment(textFormat) RESULT(textAlignment)
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_F_POINTER, C_F_PROCPOINTER
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    CLASS(IDWriteTextFormat), INTENT(INOUT) :: textFormat
    INTEGER(DWRITE_TEXT_ALIGNMENT) :: textAlignment
    
    !---------------------------------------------------------------------------
    ! Local variables
    
    TYPE(IDWriteTextFormatVTbl), POINTER :: ptbl
    PROCEDURE(GetTextAlignment_intf), POINTER :: proc
    
    !***************************************************************************
    
    CALL C_F_POINTER(VTable(textFormat), ptbl)
    CALL C_F_PROCPOINTER(ptbl%GetTextAlignment, proc)
    
    textAlignment = proc(textFormat%object)
    
  END FUNCTION GetTextAlignment
  
  
  !*****************************************************************************
  
  FUNCTION GetParagraphAlignment(textFormat) RESULT(paragraphAlignment)
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_F_POINTER, C_F_PROCPOINTER
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    CLASS(IDWriteTextFormat), INTENT(INOUT) :: textFormat
    INTEGER(DWRITE_PARAGRAPH_ALIGNMENT) :: paragraphAlignment
    
    !---------------------------------------------------------------------------
    ! Local variables
    
    TYPE(IDWriteTextFormatVTbl), POINTER :: ptbl
    PROCEDURE(GetParagraphAlignment_intf), POINTER :: proc
    
    !***************************************************************************
    
    CALL C_F_POINTER(VTable(textFormat), ptbl)
    CALL C_F_PROCPOINTER(ptbl%GetParagraphAlignment, proc)
    
    paragraphAlignment = proc(textFormat%object)
    
  END FUNCTION GetParagraphAlignment
  
  
  !*****************************************************************************
  
  FUNCTION GetWordWrapping(textFormat) RESULT(wordWrapping)
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_F_POINTER, C_F_PROCPOINTER
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    CLASS(IDWriteTextFormat), INTENT(INOUT) :: textFormat
    INTEGER(DWRITE_WORD_WRAPPING) :: wordWrapping
    
    !---------------------------------------------------------------------------
    ! Local variables
    
    TYPE(IDWriteTextFormatVTbl), POINTER :: ptbl
    PROCEDURE(GetWordWrapping_intf), POINTER :: proc
    
    !***************************************************************************
    
    CALL C_F_POINTER(VTable(textFormat), ptbl)
    CALL C_F_PROCPOINTER(ptbl%GetWordWrapping, proc)
    
    wordWrapping = proc(textFormat%object)
    
  END FUNCTION GetWordWrapping
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! IDWriteTypography
  
  
  !*****************************************************************************
  
  FUNCTION typography_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: typography_IID
    
    !***************************************************************************
    
    typography_IID = GUID(  &
        INT(Z'55F1112B', C_INT32_T),  &
        INT(Z'1DC2', C_INT16_T),  &
        INT(Z'4B3C', C_INT16_T),  &
        [ INT(Z'95', C_SIGNED_CHAR), INT(Z'41', C_SIGNED_CHAR),  &
          INT(Z'F4', C_SIGNED_CHAR), INT(Z'68', C_SIGNED_CHAR),  &
          INT(Z'94', C_SIGNED_CHAR), INT(Z'ED', C_SIGNED_CHAR),  &
          INT(Z'85', C_SIGNED_CHAR), INT(Z'B6', C_SIGNED_CHAR) ] )
    
  END FUNCTION typography_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! IDWriteNumberSubstitution
  
  
  !*****************************************************************************
  
  FUNCTION numbersubstitution_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: numbersubstitution_IID
    
    !***************************************************************************
    
    numbersubstitution_IID = GUID(  &
        INT(Z'14885CC9', C_INT32_T),  &
        INT(Z'BAB0', C_INT16_T),  &
        INT(Z'4F90', C_INT16_T),  &
        [ INT(Z'B6', C_SIGNED_CHAR), INT(Z'ED', C_SIGNED_CHAR),  &
          INT(Z'5C', C_SIGNED_CHAR), INT(Z'36', C_SIGNED_CHAR),  &
          INT(Z'6A', C_SIGNED_CHAR), INT(Z'2C', C_SIGNED_CHAR),  &
          INT(Z'D0', C_SIGNED_CHAR), INT(Z'3D', C_SIGNED_CHAR) ] )
    
  END FUNCTION numbersubstitution_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! IDWriteTextAnalysisSource
  
  
  !*****************************************************************************
  
  FUNCTION textanalysissource_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: textanalysissource_IID
    
    !***************************************************************************
    
    textanalysissource_IID = GUID(  &
        INT(Z'688E1A58', C_INT32_T),  &
        INT(Z'5094', C_INT16_T),  &
        INT(Z'47C8', C_INT16_T),  &
        [ INT(Z'AD', C_SIGNED_CHAR), INT(Z'C8', C_SIGNED_CHAR),  &
          INT(Z'FB', C_SIGNED_CHAR), INT(Z'CE', C_SIGNED_CHAR),  &
          INT(Z'A6', C_SIGNED_CHAR), INT(Z'0A', C_SIGNED_CHAR),  &
          INT(Z'E9', C_SIGNED_CHAR), INT(Z'2B', C_SIGNED_CHAR) ] )
    
  END FUNCTION textanalysissource_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! IDWriteTextAnalysisSink
  
  
  !*****************************************************************************
  
  FUNCTION textanalysissink_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: textanalysissink_IID
    
    !***************************************************************************
    
    textanalysissink_IID = GUID(  &
        INT(Z'5810CD44', C_INT32_T),  &
        INT(Z'0CA0', C_INT16_T),  &
        INT(Z'4701', C_INT16_T),  &
        [ INT(Z'B3', C_SIGNED_CHAR), INT(Z'FA', C_SIGNED_CHAR),  &
          INT(Z'BE', C_SIGNED_CHAR), INT(Z'C5', C_SIGNED_CHAR),  &
          INT(Z'18', C_SIGNED_CHAR), INT(Z'2A', C_SIGNED_CHAR),  &
          INT(Z'E4', C_SIGNED_CHAR), INT(Z'F6', C_SIGNED_CHAR) ] )
    
  END FUNCTION textanalysissink_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! IDWriteTextAnalyzer
  
  
  !*****************************************************************************
  
  FUNCTION textanalyzer_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: textanalyzer_IID
    
    !***************************************************************************
    
    textanalyzer_IID = GUID(  &
        INT(Z'B7E6163E', C_INT32_T),  &
        INT(Z'7F46', C_INT16_T),  &
        INT(Z'43B4', C_INT16_T),  &
        [ INT(Z'84', C_SIGNED_CHAR), INT(Z'B3', C_SIGNED_CHAR),  &
          INT(Z'E4', C_SIGNED_CHAR), INT(Z'E6', C_SIGNED_CHAR),  &
          INT(Z'24', C_SIGNED_CHAR), INT(Z'9C', C_SIGNED_CHAR),  &
          INT(Z'36', C_SIGNED_CHAR), INT(Z'5D', C_SIGNED_CHAR) ] )
    
  END FUNCTION textanalyzer_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! IDWriteInlineObject
  
  
  !*****************************************************************************
  
  FUNCTION inlineobject_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: inlineobject_IID
    
    !***************************************************************************
    
    inlineobject_IID = GUID(  &
        INT(Z'8339FDE3', C_INT32_T),  &
        INT(Z'106F', C_INT16_T),  &
        INT(Z'47AB', C_INT16_T),  &
        [ INT(Z'83', C_SIGNED_CHAR), INT(Z'73', C_SIGNED_CHAR),  &
          INT(Z'1C', C_SIGNED_CHAR), INT(Z'62', C_SIGNED_CHAR),  &
          INT(Z'95', C_SIGNED_CHAR), INT(Z'EB', C_SIGNED_CHAR),  &
          INT(Z'10', C_SIGNED_CHAR), INT(Z'B3', C_SIGNED_CHAR) ] )
    
  END FUNCTION inlineobject_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! IDWritePixelSnapping
  
  
  !*****************************************************************************
  
  FUNCTION pixelsnapping_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: pixelsnapping_IID
    
    !***************************************************************************
    
    pixelsnapping_IID = GUID(  &
        INT(Z'EAF3A2DA', C_INT32_T),  &
        INT(Z'ECF4', C_INT16_T),  &
        INT(Z'4D24', C_INT16_T),  &
        [ INT(Z'B6', C_SIGNED_CHAR), INT(Z'44', C_SIGNED_CHAR),  &
          INT(Z'B3', C_SIGNED_CHAR), INT(Z'4F', C_SIGNED_CHAR),  &
          INT(Z'68', C_SIGNED_CHAR), INT(Z'42', C_SIGNED_CHAR),  &
          INT(Z'02', C_SIGNED_CHAR), INT(Z'4B', C_SIGNED_CHAR) ] )
    
  END FUNCTION pixelsnapping_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! IDWriteTextRenderer
  
  
  !*****************************************************************************
  
  FUNCTION renderer_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: renderer_IID
    
    !***************************************************************************
    
    renderer_IID = GUID(  &
        INT(Z'EF8A8135', C_INT32_T),  &
        INT(Z'5CC6', C_INT16_T),  &
        INT(Z'45FE', C_INT16_T),  &
        [ INT(Z'88', C_SIGNED_CHAR), INT(Z'25', C_SIGNED_CHAR),  &
          INT(Z'C5', C_SIGNED_CHAR), INT(Z'A0', C_SIGNED_CHAR),  &
          INT(Z'72', C_SIGNED_CHAR), INT(Z'4E', C_SIGNED_CHAR),  &
          INT(Z'B8', C_SIGNED_CHAR), INT(Z'19', C_SIGNED_CHAR) ] )
    
  END FUNCTION renderer_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! IDWriteTextLayout
  
  
  !*****************************************************************************
  
  FUNCTION textlayout_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: textlayout_IID
    
    !***************************************************************************
    
    textlayout_IID = GUID(  &
        INT(Z'53737037', C_INT32_T),  &
        INT(Z'6D14', C_INT16_T),  &
        INT(Z'410B', C_INT16_T),  &
        [ INT(Z'9B', C_SIGNED_CHAR), INT(Z'FE', C_SIGNED_CHAR),  &
          INT(Z'0B', C_SIGNED_CHAR), INT(Z'18', C_SIGNED_CHAR),  &
          INT(Z'2B', C_SIGNED_CHAR), INT(Z'B7', C_SIGNED_CHAR),  &
          INT(Z'09', C_SIGNED_CHAR), INT(Z'61', C_SIGNED_CHAR) ] )
    
  END FUNCTION textlayout_IID
  
  
  !*****************************************************************************
  
  SUBROUTINE GetMetrics(textLayout, textMetrics, hr)
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_F_POINTER, C_F_PROCPOINTER
    
    !---------------------------------------------------------------------------
    ! Arguments
    
    TYPE(IDWriteTextLayout), INTENT(IN) :: textLayout
    TYPE(DWRITE_TEXT_METRICS), INTENT(OUT) :: textMetrics
    INTEGER(HRESULT), INTENT(OUT) :: hr
    
    !---------------------------------------------------------------------------
    ! Local variables
    
    TYPE(IDWriteTextLayoutVTbl), POINTER :: ptbl
    PROCEDURE(GetMetrics_intf), POINTER :: proc
    
    !***************************************************************************
    
    CALL C_F_POINTER(VTable(textLayout), ptbl)
    CALL C_F_PROCPOINTER(ptbl%GetMetrics, proc)
    
    hr = proc(textLayout%object, textMetrics)
    
  END SUBROUTINE GetMetrics
  
  
  !*****************************************************************************
  
  SUBROUTINE DetermineMinWidth(textLayout, minWidth, hr)
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_F_POINTER, C_F_PROCPOINTER
    
    !---------------------------------------------------------------------------
    ! Arguments
    
    TYPE(IDWriteTextLayout), INTENT(IN) :: textLayout
    REAL(FLOAT), INTENT(OUT) :: minWidth
    INTEGER(HRESULT), INTENT(OUT) :: hr
    
    !---------------------------------------------------------------------------
    ! Local variables
    
    TYPE(IDWriteTextLayoutVTbl), POINTER :: ptbl
    PROCEDURE(DetermineMinWidth_intf), POINTER :: proc
    
    !***************************************************************************
    
    CALL C_F_POINTER(VTable(textLayout), ptbl)
    CALL C_F_PROCPOINTER(ptbl%DetermineMinWidth, proc)
    
    hr = proc(textLayout%object, minWidth)
    
  END SUBROUTINE DetermineMinWidth
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! IDWriteBitmapRenderTarget
  
  
  !*****************************************************************************
  
  FUNCTION bitmaprendertarget_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: bitmaprendertarget_IID
    
    !***************************************************************************
    
    bitmaprendertarget_IID = GUID(  &
        INT(Z'5E5A32A3', C_INT32_T),  &
        INT(Z'8DFF', C_INT16_T),  &
        INT(Z'4773', C_INT16_T),  &
        [ INT(Z'9F', C_SIGNED_CHAR), INT(Z'F6', C_SIGNED_CHAR),  &
          INT(Z'06', C_SIGNED_CHAR), INT(Z'96', C_SIGNED_CHAR),  &
          INT(Z'EA', C_SIGNED_CHAR), INT(Z'B7', C_SIGNED_CHAR),  &
          INT(Z'72', C_SIGNED_CHAR), INT(Z'67', C_SIGNED_CHAR) ] )
    
  END FUNCTION bitmaprendertarget_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! IDWriteGdiInterop
  
  
  !*****************************************************************************
  
  FUNCTION gdiinterop_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: gdiinterop_IID
    
    !***************************************************************************
    
    gdiinterop_IID = GUID(  &
        INT(Z'1EDD9491', C_INT32_T),  &
        INT(Z'9853', C_INT16_T),  &
        INT(Z'4299', C_INT16_T),  &
        [ INT(Z'89', C_SIGNED_CHAR), INT(Z'8F', C_SIGNED_CHAR),  &
          INT(Z'64', C_SIGNED_CHAR), INT(Z'32', C_SIGNED_CHAR),  &
          INT(Z'98', C_SIGNED_CHAR), INT(Z'3B', C_SIGNED_CHAR),  &
          INT(Z'6F', C_SIGNED_CHAR), INT(Z'3A', C_SIGNED_CHAR) ] )
    
  END FUNCTION gdiinterop_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! IDWriteGlyphRunAnalysis
  
  
  !*****************************************************************************
  
  FUNCTION glyphrunanalysis_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: glyphrunanalysis_IID
    
    !***************************************************************************
    
    glyphrunanalysis_IID = GUID(  &
        INT(Z'7D97DBF7', C_INT32_T),  &
        INT(Z'E085', C_INT16_T),  &
        INT(Z'4D42', C_INT16_T),  &
        [ INT(Z'81', C_SIGNED_CHAR), INT(Z'E3', C_SIGNED_CHAR),  &
          INT(Z'6A', C_SIGNED_CHAR), INT(Z'88', C_SIGNED_CHAR),  &
          INT(Z'3B', C_SIGNED_CHAR), INT(Z'DE', C_SIGNED_CHAR),  &
          INT(Z'D1', C_SIGNED_CHAR), INT(Z'18', C_SIGNED_CHAR) ] )
    
  END FUNCTION glyphrunanalysis_IID
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! DWriteFactory
  
  
  !*****************************************************************************
  
  FUNCTION factory_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: factory_IID
    
    !***************************************************************************
    
    factory_IID = GUID(  &
        INT(Z'B859EE5A', C_INT32_T),  &
        INT(Z'D838', C_INT16_T),  &
        INT(Z'4B5B', C_INT16_T),  &
        [ INT(Z'A2', C_SIGNED_CHAR), INT(Z'E8', C_SIGNED_CHAR),  &
          INT(Z'1A', C_SIGNED_CHAR), INT(Z'DC', C_SIGNED_CHAR),  &
          INT(Z'7D', C_SIGNED_CHAR), INT(Z'93', C_SIGNED_CHAR),  &
          INT(Z'DB', C_SIGNED_CHAR), INT(Z'48', C_SIGNED_CHAR) ] )
    
  END FUNCTION factory_IID
  
  
  !*****************************************************************************
  
  SUBROUTINE CreateTextFormat_utf8( factory, fontFamilyName,  &
      fontWeight, fontStyle, fontStretch, fontSize, localeName, textFormat,  &
      hr, fontCollection )
    
    !---------------------------------------------------------------------------
    ! Arguments
    
    TYPE(IDWriteFactory), INTENT(IN) :: factory
    CHARACTER(*), INTENT(IN) :: fontFamilyName
    INTEGER(DWRITE_FONT_WEIGHT), INTENT(IN) :: fontWeight
    INTEGER(DWRITE_FONT_STYLE), INTENT(IN) :: fontStyle
    INTEGER(DWRITE_FONT_STRETCH), INTENT(IN) :: fontStretch
    REAL(FLOAT), INTENT(IN) :: fontSize
    CHARACTER(*), INTENT(IN) :: localeName
    TYPE(IDWriteTextFormat), INTENT(OUT) :: textFormat
    INTEGER(HRESULT), INTENT(OUT) :: hr
    TYPE(IDWriteFontCollection), INTENT(IN), OPTIONAL :: fontCollection
    
    !***************************************************************************
    
    CALL CreateTextFormat(  &
        factory,  &
        UTF8ToUTF16(fontFamilyName),  &
        fontWeight,  &
        fontStyle,  &
        fontStretch,  &
        fontSize,  &
        UTF8ToUTF16(localeName),  &
        textFormat,  &
        hr,  &
        fontCollection )
    
  END SUBROUTINE CreateTextFormat_utf8
  
  
  !*****************************************************************************
  
  SUBROUTINE CreateTextFormat_utf16( factory, fontFamilyName, fontWeight,  &
      fontStyle, fontStretch, fontSize, localeName, textFormat,  &
      hr, fontCollection )
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR, C_F_POINTER,  &
        C_F_PROCPOINTER, C_NULL_PTR
    
    !---------------------------------------------------------------------------
    ! Arguments
    
    TYPE(IDWriteFactory), INTENT(IN) :: factory
    INTEGER(WCHAR), INTENT(IN) :: fontFamilyName(:)
    INTEGER(DWRITE_FONT_WEIGHT), INTENT(IN) :: fontWeight
    INTEGER(DWRITE_FONT_STYLE), INTENT(IN) :: fontStyle
    INTEGER(DWRITE_FONT_STRETCH), INTENT(IN) :: fontStretch
    REAL(FLOAT), INTENT(IN) :: fontSize
    INTEGER(WCHAR), INTENT(IN) :: localeName(:)
    TYPE(IDWriteTextFormat), INTENT(OUT) :: textFormat
    INTEGER(HRESULT), INTENT(OUT) :: hr
    TYPE(IDWriteFontCollection), INTENT(IN), OPTIONAL :: fontCollection
    
    !---------------------------------------------------------------------------
    ! Local variables
    
    INTEGER(WCHAR) :: local_family(SIZE(fontFamilyName) + 1)
    INTEGER(WCHAR) :: local_locale(SIZE(localeName) + 1)
    
    TYPE(C_PTR) :: local_collection
    
    TYPE(IDWriteFactoryVTbl), POINTER :: ptbl
    PROCEDURE(CreateTextFormat_intf), POINTER :: proc
    
    !***************************************************************************
    
    local_family = [fontFamilyName, 0_WCHAR]
    local_locale = [localename, 0_WCHAR]
    
    IF (PRESENT(fontCollection)) THEN
      local_collection = fontCollection%object
    ELSE
      local_collection = C_NULL_PTR
    END IF
    
    CALL C_F_POINTER(VTable(factory), ptbl)
    CALL C_F_PROCPOINTER(ptbl%CreateTextFormat, proc)
    
    hr = proc(  &
        factory%object,  &
        local_family,  &
        local_collection,  &
        fontWeight,  &
        fontStyle,  &
        fontStretch,  &
        fontSize,  &
        local_locale,  &
        textFormat%object )
    
  END SUBROUTINE CreateTextFormat_utf16
  
  
  !*****************************************************************************
  
  SUBROUTINE CreateTextLayout_utf16( factory, string, textFormat, maxWidth,  &
      maxHeight, textLayout, hr )
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_F_POINTER, C_F_PROCPOINTER
    
    !---------------------------------------------------------------------------
    ! Arguments
    
    TYPE(IDWriteFactory), INTENT(IN) :: factory
    INTEGER(WCHAR), INTENT(IN) :: string(:)
    TYPE(IDWriteTextFormat), INTENT(IN) :: textFormat
    REAL(FLOAT), INTENT(IN) :: maxWidth
    REAL(FLOAT), INTENT(IN) :: maxHeight
    TYPE(IDWriteTextLayout), INTENT(OUT) :: textLayout
    INTEGER(HRESULT), INTENT(OUT) :: hr
    
    !---------------------------------------------------------------------------
    ! Local variables
    
    TYPE(IDWriteFactoryVTbl), POINTER :: ptbl
    PROCEDURE(CreateTextLayout_intf), POINTER :: proc
    
    !***************************************************************************
    
    CALL C_F_POINTER(VTable(factory), ptbl)
    CALL C_F_PROCPOINTER(ptbl%CreateTextLayout, proc)
    
    hr = proc(  &
        factory%object,  &
        string,  &
        SIZE(string, KIND=UINT32),  &
        textFormat%object,  &
        maxWidth,  &
        maxHeight,  &
        textLayout%object )
    
  END SUBROUTINE CreateTextLayout_utf16
  
  
  SUBROUTINE CreateTextLayout_utf8( factory, string, textFormat, maxWidth,  &
      maxHeight, textLayout, hr )
    
    !---------------------------------------------------------------------------
    ! Arguments
    
    TYPE(IDWriteFactory), INTENT(IN) :: factory
    CHARACTER(*), INTENT(IN) :: string
    TYPE(IDWriteTextFormat), INTENT(IN) :: textFormat
    REAL(FLOAT), INTENT(IN) :: maxWidth
    REAL(FLOAT), INTENT(IN) :: maxHeight
    TYPE(IDWriteTextLayout), INTENT(OUT) :: textLayout
    INTEGER(HRESULT), INTENT(OUT) :: hr
    
    !***************************************************************************
    
    CALL CreateTextLayout(  &
        factory,  &
        UTF8ToUTF16(string),  &
        textFormat,  &
        maxWidth,  &
        maxHeight,  &
        textLayout,  &
        hr )
    
  END SUBROUTINE CreateTextLayout_utf8
  
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Free standing procedures.
  
  
  !*****************************************************************************
  
  SUBROUTINE DWriteCreateFactory(factoryType, factory, hr)
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Arguments
    
    INTEGER(DWRITE_FACTORY_TYPE), INTENT(IN) :: factoryType
    TYPE(IDWriteFactory), INTENT(OUT) :: factory
    INTEGER(HRESULT), INTENT(OUT) :: hr
    
    !---------------------------------------------------------------------------
    
    INTERFACE
      FUNCTION DWriteCreateFactory_l(factoryType, riid, ppIFactory) RESULT(hr)
        USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_PTR, C_LONG
        IMPORT :: DWRITE_FACTORY_TYPE
        IMPORT :: GUID
        IMPORT :: HRESULT
        IMPLICIT NONE
        !-----------------------------------------------------------------------
        INTEGER(DWRITE_FACTORY_TYPE), INTENT(IN) :: factoryType
        TYPE(GUID), INTENT(IN) :: riid
        !DEC$ ATTRIBUTES REFERENCE :: riid
        TYPE(C_PTR), INTENT(OUT) :: ppIFactory
        !DEC$ ATTRIBUTES REFERENCE :: ppIFactory
        INTEGER(HRESULT) :: hr
        !DEC$ ATTRIBUTES STDCALL :: DWriteCreateFactory_l
        !DEC$ ATTRIBUTES ALIAS:'DWriteCreateFactory' :: DWriteCreateFactory_l
        !DEC$ ATTRIBUTES DECORATE :: DWriteCreateFactory_l
      END FUNCTION DWriteCreateFactory_l
    END INTERFACE
    
    !***************************************************************************
    
    hr = DWriteCreateFactory_l(  &
        factoryType,  &
        factory%IID(),  &
        factory%object )
    
  END SUBROUTINE DWriteCreateFactory
  
END MODULE DirectWrite
