! $Id: DirectX.f90 2116 2016-05-11 11:41:04Z ian $
! Copyright 2016 M.E.G.M.S.  See LICENCE.txt for licence (Apache 2.0).
! See http://www.megms.com.au/winapi-bindings.htm for more information.



!*******************************************************************************

MODULE DirectX
  
  USE COMBase
  
  USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_LONG
  
  IMPLICIT NONE
  
  !-----------------------------------------------------------------------------
  ! Pixel format enumeration (from dxgiformat.h)
  
  INTEGER, PARAMETER, PUBLIC :: DXGI_FORMAT = C_LONG
  
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_UNKNOWN = 0
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R32G32B32A32_TYPELESS = 1
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R32G32B32A32_FLOAT = 2
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R32G32B32A32_UINT = 3
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R32G32B32A32_SINT = 4
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R32G32B32_TYPELESS = 5
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R32G32B32_FLOAT = 6
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R32G32B32_UINT = 7
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R32G32B32_SINT = 8
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R16G16B16A16_TYPELESS = 9
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R16G16B16A16_FLOAT = 10
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R16G16B16A16_UNORM = 11
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R16G16B16A16_UINT = 12
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R16G16B16A16_SNORM = 13
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R16G16B16A16_SINT = 14
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R32G32_TYPELESS = 15
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R32G32_FLOAT = 16
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R32G32_UINT = 17
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R32G32_SINT = 18
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R32G8X24_TYPELESS = 19
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_D32_FLOAT_S8X24_UINT = 20
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R32_FLOAT_X8X24_TYPELESS = 21
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_X32_TYPELESS_G8X24_UINT = 22
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R10G10B10A2_TYPELESS = 23
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R10G10B10A2_UNORM = 24
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R10G10B10A2_UINT = 25
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R11G11B10_FLOAT = 26
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R8G8B8A8_TYPELESS = 27
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R8G8B8A8_UNORM = 28
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R8G8B8A8_UNORM_SRGB = 29
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R8G8B8A8_UINT = 30
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R8G8B8A8_SNORM = 31
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R8G8B8A8_SINT = 32
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R16G16_TYPELESS = 33
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R16G16_FLOAT = 34
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R16G16_UNORM = 35
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R16G16_UINT = 36
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R16G16_SNORM = 37
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R16G16_SINT = 38
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R32_TYPELESS = 39
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_D32_FLOAT = 40
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R32_FLOAT = 41
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R32_UINT = 42
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R32_SINT = 43
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R24G8_TYPELESS = 44
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_D24_UNORM_S8_UINT = 45
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R24_UNORM_X8_TYPELESS = 46
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_X24_TYPELESS_G8_UINT = 47
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R8G8_TYPELESS = 48
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R8G8_UNORM = 49
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R8G8_UINT = 50
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R8G8_SNORM = 51
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R8G8_SINT = 52
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R16_TYPELESS = 53
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R16_FLOAT = 54
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_D16_UNORM = 55
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R16_UNORM = 56
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R16_UINT = 57
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R16_SNORM = 58
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R16_SINT = 59
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R8_TYPELESS = 60
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R8_UNORM = 61
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R8_UINT = 62
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R8_SNORM = 63
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R8_SINT = 64
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_A8_UNORM = 65
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R1_UNORM = 66
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R9G9B9E5_SHAREDEXP = 67
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R8G8_B8G8_UNORM = 68
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_G8R8_G8B8_UNORM = 69
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_BC1_TYPELESS = 70
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_BC1_UNORM = 71
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_BC1_UNORM_SRGB = 72
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_BC2_TYPELESS = 73
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_BC2_UNORM = 74
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_BC2_UNORM_SRGB = 75
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_BC3_TYPELESS = 76
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_BC3_UNORM = 77
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_BC3_UNORM_SRGB = 78
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_BC4_TYPELESS = 79
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_BC4_UNORM = 80
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_BC4_SNORM = 81
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_BC5_TYPELESS = 82
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_BC5_UNORM = 83
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_BC5_SNORM = 84
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_B5G6R5_UNORM = 85
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_B5G5R5A1_UNORM = 86
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_B8G8R8A8_UNORM = 87
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_B8G8R8X8_UNORM = 88
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_R10G10B10_XR_BIAS_A2_UNORM = 89
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_B8G8R8A8_TYPELESS = 90
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_B8G8R8A8_UNORM_SRGB = 91
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_B8G8R8X8_TYPELESS = 92
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_B8G8R8X8_UNORM_SRGB = 93
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_BC6H_TYPELESS = 94
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_BC6H_UF16 = 95
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_BC6H_SF16 = 96
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_BC7_TYPELESS = 97
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_BC7_UNORM = 98
  INTEGER(DXGI_FORMAT), PARAMETER, PUBLIC  &
      :: DXGI_FORMAT_BC7_UNORM_SRGB = 99
  
  !-----------------------------------------------------------------------------
  ! "cafcb56c-6ac3-4889-bf47-9e23bbd260ec"  IDXGISurface
  !
  ! "cafcb56c-6ac3-4889-bf47-9e23bbd260ec"
  
  TYPE, EXTENDS(IUnknown) :: IDXGISurface
  CONTAINS
    PROCEDURE, NOPASS :: IID => dxgisurface_IID
  END TYPE IDXGISurface
  
CONTAINS
  
  !-----------------------------------------------------------------------------
  !-----------------------------------------------------------------------------
  !
  ! Procedures for IDXGISurface
  
  
  !*****************************************************************************
  
  FUNCTION dxgisurface_IID()
    
    USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT32_T, C_INT16_T, C_SIGNED_CHAR
    
    !---------------------------------------------------------------------------
    ! Characteristics
    
    TYPE(GUID) :: dxgisurface_IID
    
    !***************************************************************************
    
    dxgisurface_IID = GUID(  &
        INT(Z'CAFCB56C', C_INT32_T),  &
        INT(Z'6AC3', C_INT16_T),  &
        INT(Z'4889', C_INT16_T),  &
        [ INT(Z'BF', C_SIGNED_CHAR), INT(Z'47', C_SIGNED_CHAR),  &
          INT(Z'9E', C_SIGNED_CHAR), INT(Z'23', C_SIGNED_CHAR),  &
          INT(Z'BB', C_SIGNED_CHAR), INT(Z'D2', C_SIGNED_CHAR),  &
          INT(Z'60', C_SIGNED_CHAR), INT(Z'EC', C_SIGNED_CHAR) ] )
    
  END FUNCTION dxgisurface_IID
  
END MODULE DirectX
